c
code for weiagr
      subroutine weiagr
c--dummy routine to identify the module
c
      return
      end
c
code for cwdir
      subroutine cwdir(in,ier)
c--read directives for automatic weighting scheme routine
c  in = 0 read directives
c	1 set only default
c
      common/funit/ncfu(9),nfon(9)
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,ndd,ni,ntt,na(3),ncd,idoc(20)
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      dimension cod(30)
      equivalence(icod,cod)
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c--
      dimension itarg(16)
      character*40 iarg
      data iarg/'instruction(s) or ##'/
      data jnat/16/
      data itarg/4hprin,
     2           4hcycl,
     3           4hinte,
     4           4herro,
     5           4hfudg,
     6		 4hverb,
     7		 4hdivi,
     8		 4hno  ,
     9		 4hdist,
     *		 4htype,
     1		 4hhcyc,
     2		 4haver,
     3		 4hnew ,
     4		 4hmodi,
     5		 4htabl,
     6		 4hend /
c--
c-- set default values
      do i=1,30
       icod(i)=0
      enddo
      icod(1)=0 		! print
      icod(2)=10
      icod(3)=8
      cod(4)=0.02
      cod(5)=1.0
      icod(7)=0 		 ! verbose 0/1/2
      icod(15)=1		 ! refine coeff
      icod(18)=1		 ! code: (0/1) divide/non divide 
      icod(20)=0		 ! n. intermediate cycles
      icod(21)=1		 ! refinement type
      cod(22)=0.0		 ! average value
      icod(23)=2		 ! fo and sin(theta)/lambda
      icod(24)=0		 ! 0/1 old/new method
      icod(25)=1000
      icod(26)=0		 ! code se w deve essere modificato
      cod(27)=6 		 ! n times per la modifica
      icod(28)=0		 ! code se scrivere file .num (not used)
c--
      ier=0
      if(in.eq.1) goto 9010
      if(idefa(i)) 1000,1000,9000
1000  continue
      call sty(iarg)
c
c--main loop for processing input instructions
c--fetch the next card
 2000 continue
      if(klnc(2)) 9000,2020,9000
c-- card to be interpreted
 2020 continue
      call xpcci
      if(jrca(itemp,n)) 2060,2040,2060
c--process the directive
 2040 continue
      n=kcomp(1,itemp,itarg,jnat,1)
      if(n) 2060,2060,2050
 2050 continue
c--	    /2hpr,2hcy,2hin,2hnc,2hfu,2hve,
      go to (2100,2200,2300,2400,2500,2600,
c--	    /2hdi,2hno,2hdi,2hty,2hhc,2hav,2hne,
     1	     2700,2800,2900,3000,3100,3200,3300,
c--	    /2hmo,2hta,2hen/
     2	     3870,3400,9000),n
2060  continue
      call xunkw
      go to 2000
c
c--'print' directive
 2100 continue
      icod(1)=1
      go to 2000
c
c--'cycle' directive
2200  continue
      icod(2)=kredi(i)
      if(icod(2).eq.0.or.icod(2).gt.10) icod(2)=10
      go to 2000
c
c--'interv' directive  (n.di intervalli)
c   primo valore per la stampa delle tabelle finali , il secondo per l'analisi
2300  continue
      icod(25)=kredi(i)
      if(icod(25).eq.0) icod(25)=1000
      icod(3)=kredi(i)
      if(icod(3).eq.0) icod(3)=8
      go to 2000
c
c--'errorpsi' directive
2400  continue
      if(jredf(temp,1)) 2060,2492,2492
2492  continue
      if(temp(1).le.0.0) temp(1)=0.02
      cod(4)=temp(1)
      go to 2000
c
c--'fudge' directive
2500  continue
      if(jredf(temp,1)) 2060,2592,2592
2592  continue
      if(temp(1).eq.0.0) temp(1)=1.0
      cod(5)=temp(1)
      goto 2000
c
c--'verbose' directive
2600  continue
      icod(7)=kredi(i)
      if(icod(7).eq.0) icod(7)=1
      go to 2000
c
c--'divide' directive
2700  continue
      icod(18)=0
      go to 2000
c
c--'no' directive
2800  continue
      icod(15)=0
      go to 2000
c
c--'distrib' directive
2900  continue
      icod(23)=kredi(i)
      if(icod(23).eq.0) icod(23)=2
      go to 2000
c
c--'type' directive
3000  continue
      icod(21)=kredi(i)
      if(icod(21).eq.0) icod(21)=1
      go to 2000
c
c--'hcycle' directive
3100  continue
      icod(20)=kredi(i)
      go to 2000
c
c--'average' directive
3200  continue
      if(jredf(temp,1)) 2060,3202,3202
3202  continue
      if(temp(1).le.0.0) temp(1)=1.0
      cod(22)=temp(1)
      go to 2000
c
c--'new' directive
3300  continue
      icod(24)=1
      go to 2000
c
c--'modify' directive
3870  continue
      if(jredf(temp,2)) 2060,3871,2060
3871  continue
      icod(26)=temp(1)
      cod(27)=temp(2)
      go to 2000
c
c--'table' directive (not more used)
 3400 continue
c--	icod(28)=1
      go to 2000
c
c--'end' directive
9000  continue
      if(iabort)9005,9005,9100
9005  continue
      call wauto(ier)
9010  continue
      return
9100  continue
      iabort=0
      return
      end
c
code for wauto
      subroutine wauto(ier)
c--main routine for cruickshank's coeficents automatic determination
c--read list for weighting scheme optimization
c  call xweight
c  print results
c--
      include 'li6com.inc'
c
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i               
     3 ,l2a,l2b,l2c,l2d,l2j,noric
      common/lst04/iw4,l4,m4,n4
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/funit/ncfu(9),nfon(9)
      character*60 carctr,ifmt,file
      common/cfile/ carctr,ifmt
      character*60 idfle,stfle
      common/cdisu/idfle,stfle
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      dimension cod(30)
      equivalence(icod,cod)
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      common /xlst11/ l11r,m11r,md11r,n11r,l11s,m11s,md11s,n11s
      common /xlim11/ nfld,lfld,nld
c
      dimension norrif(1001),fo(2,1001),sd2w(1001)
      dimension icar(3),itit(15),iti1(15)
      dimension hl(12)
      character*4 ext1
      data ext1/'.num'/
      data icar/1hw,1hd,1h*/
      data itit/2hs(,2hT),2h/l,2hFo,2h-F,2hc ,
     1		2h1.,2h/w,2h  ,2hFo,2h-F,2hc ,
     2		2h  ,2h  ,2h  /
      data iti1/2hFo,2h  ,2h  ,2hFo,2h-F,2hc ,
     1		2h1.,2h/w,2h  ,2hFo,2h-F,2hc ,
     2		2h  ,2h  ,2h  /

c      icod(7)=1
c
c--read down the lists
      nfld=1
      call xcsae
      call xrsl
      call xfl01
      call xfl02
      l2p=nfl
      call xlat(hl)
      nfl=nfl+n2p*md2p
      l=n2p*3
      m2p=l2p
      do i=1,l
      store(m2p)=hl(i)
      m2p=m2p+1
      enddo
      call xfl03
      call xfl04
      call xfl05
      call xfl06
      jq=1
      ll=nfl
      call sfl12
      if(jfr22(ix)) 35,36,36
35    continue
      call xerr
      write(ncwu,*)' errore in lista 12 o in iopen'
      ier=-1
      return
36    continue
      nfl=ll
      call sfl22
      if(jab22(ix)) 35,37,37
37    continue
      if(nfon(2).eq.1) then
       ncfuc=ncfu(2)
       write(ncfuc,'(i10)') iw4
      endif
c
c-- store list 6 in memoria
      il6=6
      j=0
      icode=0
      call xsto6(il6,j,icode,in)
c--
      m6=lxxe
      do i=1,nxxe
      store(m6+7)=sqrt(store(m6+7))
      m6=m6+md6d
      enddo
c
c--calculate the optimized weighting scheme
      call xweight(wrob)
c
c--print final tables
      if(icod(7).eq.0)go to 5500
c      scalo=1.0/abs(store(l5o))
c      scalc=1.0
      scalc=abs(store(l5o))
      scalo=1.0
c--
      jfirst=0
      intervx=26
      ninterx=20
      interv=0
c      if(icod(3).ne.8) interv=icod(3)
      kk=1
      njump=3
      call sortz(lxxe,nxxe,mdxxe,njump)
      call folimi(jfirst,interv,intervx,ninterx,norrif,fo,kk)
      jfirst=1
c      do i=1,interv
c      iniz=norrif(i)
c      ifin=norrif(i+1)-1
c      contrib=float(ifin-iniz+1)
c      write(ncwu,*)'i,iniz,ifin,contrib',i,iniz,ifin,contrib
c      enddo
      lxxc=nfl
      mdxxc=2
      nxxc=interv
      nxxb=2
c--funzioni di w
      do kk=1,2
      if(kk.eq.1) then
      njump=3
      else
      njump=7
      endif
      call sortz(lxxe,nxxe,mdxxe,njump)
      call folimi(jfirst,interv,intervx,ninterx,norrif,fo,kk)
      jfirst=1
      if(nfon(2).eq.1) then
       ncfuc=ncfu(2)
       write(ncfuc,4610) nxxc
4610   format(1x,i9)
       write(ncfuc,'(a)')' fom,1/w,d2'
      endif
      mxxc=lxxc
      m6=lxxe
      nchg=0
      n4z=0
      do i=1,interv
      iniz=norrif(i)
      ifin=norrif(i+1)-1
      mxxb=mxxc
      do j=1,nxxb
      store(mxxb+1)=0.0
      mxxb=mxxb+nxxc*mdxxc
      enddo
      nrrr=0
      do k=iniz,ifin
      nrrr=nrrr+1
      fobs=store(m6+3)*scalo
      fcal=store(m6+5)*scalc
      diff=abs(fobs-fcal)
      sigmaf=store(m6+4)*scalo
      st=store(m6+7)
      call sweig(fobs,fcal,sigmaf,st,diff,w1,n4z)
      if(icod(26).ne.0) then
       w1c=w1
       call chweig(icod(26),cod(27),wrob,diff,w1,nchg,ies)
c	if(ies.ne.0) then
c	 diff2=diff*diff
c	 w2=w1*w1
c	 w3=0.0
c	 if(w2.gt.0) w3=1.0/w2
c	 write(ncwu,'(5f10.4)') fobs,diff2,w3,w1c,w1
c	endif
      endif
      diff2=diff*diff
      w2=w1*w1
      w3=0.0
      if(w2.gt.0) w3=1.0/w2
      r=0.0
      if(diff2.gt.0.0) r=abs(w3-diff2)/diff2
c      write(ncwu,1045) k,w3,w2,diff2,r,st
c1045  format(1x,i5,4f10.4,2f15.5)
c      store(mxxc+1)=store(mxxc+1)+w2
      store(mxxc+1)=store(mxxc+1)+w3
      store(mxxc+nxxc*mdxxc+1)=store(mxxc+nxxc*mdxxc+1)+diff2
c      store(mxxc+2*nxxc*mdxxc+1)=store(mxxc+2*nxxc*mdxxc+1)+w2*diff2
c      store(mxxc+3*nxxc*mdxxc+1)=store(mxxc+3*nxxc*mdxxc+1)+r
c      fff=fobs
c      fff1=st
c      if(kk.eq.2) then
c      fff=st
c      fff1=fobs
c      endif
c      write(ncwu,900)' #,fo ,1/w,d2',nrrr, fff,w3,diff2,fff1
c900   format(a,i5,4f10.3)
      m6=m6+md6d
      enddo
      fom=0.5*(fo(kk,i)+fo(kk,i+1))
      store(mxxc  )=fom
      store(mxxc+nxxc*mdxxc)=fom
      contrib=float(ifin-iniz+1)
      mxxb=mxxc
      do j=1,nxxb
      store(mxxb+1)=store(mxxb+1)/contrib
      mxxb=mxxb+nxxc*mdxxc
      enddo
c      write(ncwu,*) 'intervallo #',i,contrib
c      write(ncwu,*) 'fom,1/w,d2', store(mxxc),store(mxxc+1),
c     1	 store(mxxc+nxxc*mdxxc+1)
c--
      if(nfon(2).eq.1) then
       ncfuc=ncfu(2)
       write(ncfuc,4600)store(mxxc),store(mxxc+1),
     1	store(mxxc+nxxc*mdxxc+1)
4600   format(1x,3f15.5)
      endif
c--
      mxxc=mxxc+mdxxc
      enddo
      if(kk.eq.1) then
       write(ncwu,1010)
1010   format(/,' Plot of 1/w and d2 versus /Fo/',/)
      else
       write(ncwu,1020)
1020   format(/,' Plot of 1/w and d2 versus  Sin(theta)/Lambda ',/)
      endif
      ifit=0
      if(kk.eq.1) then
      call xplot(ncwu,lxxc,nxxc,nxxb,mdxxc,icar,iti1,ifit)
      else
      call xplot(ncwu,lxxc,nxxc,nxxb,mdxxc,icar,itit,ifit)
      endif
      write(ncwu,1011)nchg
1011  format(' Modified weight(s) =',i5)
      write(ncwu,9314)
      enddo
c
5500  continue
      if(icod(1).gt.0) then
      njump=3
      call sortz(lxxe,nxxe,mdxxe,njump)
      write(ncwu,7510)
7510  format(1x,'   h   k   l',6x,'fo',2x,'   sig(fo)',
     1 5x,'fc',5x,'weight',1x,'1/weight',1x,'/fo-fc/',1x,'w*/fo-fc/2',/)
      m6=lxxe
      nchg=0
      n4z=0
      do i=1,nxxe
      ih=store(m6  )
      ik=store(m6+1)
      il=store(m6+2)
      fobs=store(m6+3)*scalo
      fcal=store(m6+5)*scalc
      st=store(m6+7)
      diff=abs(fobs-fcal)
      sigmaf=store(m6+4)*scalo
      call sweig(fobs,fcal,sigmaf,st,diff,w1,n4z)
      w2=w1*w1
      w3=0.0
      if(w2.gt.0.0) w3=1/w2
      dw=diff*diff*w2
      write(ncwu,7520)ih,ik,il,fobs,sigmaf,fcal
     1	 ,w2,w3,diff,dw
7520  format(1x,3i4,f10.3,f9.3,f10.3,f9.3,f8.3,f8.3,f10.3)
      m6=m6+md6d
      enddo
      write(ncwu,9314)
9314  format(1h ,78(1h-))
      endif
5510  continue
      return
      end
c
code for wshelx 
      subroutine wshelx(r1)
c--calculate the coeficents for like shelx sheme 
c--
      include 'li6com.inc'
c
      common/lst04/iw4,l4,m4,n4
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      character*60 carctr,ifmt
      common/cfile/ carctr,ifmt
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      dimension cod(30)
      equivalence(icod,cod)
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      dimension det(3,3),vet(3),nre(20),rre(20),vetdum(3,3)
      dimension norrif(1001),fo(2,1001),sd2w(1000),ffo(1000)
c--
c      write(ncwu,*)' entro in wshelx'
c      scalo=1.0/abs(store(l5o))
c      scalc=1.0
      scalc=abs(store(l5o))
      scalo=1.0
c--
      jfirst=0
      intervx=1000
      ninterx=20
      interv=0
      if(icod(3).ne.8) interv=icod(3)
      kk=1
      njump=3
      call sortz(lxxe,nxxe,mdxxe,njump)
      call folimi(jfirst,interv,intervx,ninterx,norrif,fo,kk)
      jfirst=1
c      write(ncwu,*)'interv:',interv
      do i=1,3
      vet(i)=0.0
      do j=1,3
      det(i,j)=0.0
      enddo
      enddo
      m6=lxxe
      st=0.0
      do i=1,interv
      iniz=norrif(i)
      ifin=norrif(i+1)-1
c      write(ncwu,*)'iniz,ifin,kki,i',iniz,ifin,kk,i
      sd2w(i)=0.
      ffo(i)=0.
      do k=iniz,ifin
      st=store(m6+7)
      fobs=store(m6+3)*scalo
      sigma=store(m6+4)*scalo
      fcal=store(m6+5)*scalc
c      ih=store(m6  )
c      ik=store(m6+1)
c      il=store(m6+2)
c      write(ncwu,7520)ih,ik,il,fobs,sigma,fcal,st
7520  format(1x,3i4,4f10.3)
      diff=fobs-fcal
      diff2=diff*diff
      sd2w(i)=sd2w(i)+diff2
c--definisco la variabile
      variab=(fobs+2.0*fcal)/3.0
      ffo(i)=ffo(i)+variab
c      write(ncwu,*)'st,ffo',st,ffo(i),diff2,sd2w(i)
c--calculate the coefficients of the function:
c  utilizzando i valori di ogni riflesso 
c  d2 = a + b*F + c*F2	  case kk=1
c  d2 = a + b*st+ c*st2   case kk=2
c  by the ls methods
      sig2=sigma*sigma
      det(1,1)=det(1,1)+sig2*sig2
      det(1,2)=det(1,2)+variab*sig2
      det(1,3)=det(1,3)+variab*variab*sig2
      vet(1)=vet(1)+diff2*sig2
      det(2,2)=det(2,2)+variab*variab
      det(2,3)=det(2,3)+variab*variab*variab
      vet(2)=vet(2)+diff2*variab
      det(3,3)=det(3,3)+variab*variab*variab*variab
      vet(3)=vet(3)+diff2*variab*variab
      m6=m6+md6d
      enddo
      contrib=float(ifin-iniz+1)
      sd2w(i)=sd2w(i)/contrib
      ffo(i)=ffo(i)/contrib
c      write(ncwu,*)'i,sd2w(i),ffo(i),contrib:',i,sd2w(i),ffo(i),contrib
      enddo
      det(2,1)=det(1,2)
      det(3,1)=det(1,3)
      det(3,2)=det(2,3)
c--risoluzione del sistema delle eq. normali
	ider=3
	nvet=1
	do i=1,3
	vetdum(i,nvet)=vet(i)
	enddo
	call matin(det,ider,vetdum,nvet,deter)
	do i=1,3
	vet(i)=vetdum(i,nvet)
	enddo
c--controllo la equazione della parabola
c        write(ncwu,*)' vet...',vet(1),vet(2),vet(3)
c        xxx=-vet(2)/(2.0*vet(3))
c        yyy=vet(1)+vet(2)*xxx+vet(3)*xxx*xxx
c        write(ncwu,*)' xxx,yyy',xxx,yyy
c        if(yyy.lt.0) then
c        vet(1)=vet(1)-yyy+0.1
c        endif
c--save new coefficients in list 4
	do i=nfl,nfl+20
	store(i)=0.0
	enddo
	call xxcln(4)
	l=nfl+5
	store(l)=iw4
	store(l+1)=n4
	l4=l+2
c      store(l4	)=abs(vet(1))
c      store(l4+1)=abs(vet(2))
c      store(l4+2)=abs(vet(3))
      store(l4	)=vet(1)
      store(l4+1)=vet(2)
      store(l4+2)=vet(3)
      n=20
      call xfrml(4,n)
      call xfl04
c      write(ncwu,*)' new:', store(l4),store(l4+1),store(l4+2)
c--calculate r(w) indices
      if(icod(7).ge.1) then
      eps=0.
      den=0
      nchg=0
      n4z=0
      do i=1,interv
      fobs=ffo(i)
      if(iw4.eq.15) st=1.0/ffo(i)
      diff=sqrt(sd2w(i))
      sigmaf=0.0
c      write(ncwu,*)' i,fobs,fcal,sigmaf,st,diff',
c     1  i,fobs,fcal,sigmaf,st,diff
      call sweig(fobs,fcal,sigmaf,st,diff,w,n4z)
c      write(ncwu,*)' i,st,diff,w',i,st,diff,w
      w3=w*w
      w2=0.0
      if(w3.gt.0.0) w2=1.0/w3
      eps=eps+abs(sd2w(i)-w2)
      den=den+sd2w(i)
      ww=w3*sd2w(i)
c      write(ncwu,1046) ffo(i),w2,sd2w(i)
c1046  format(1x,7f10.4)
c      write(ncwu,1045) i,w3,w2,sd2w(i),ww,ffo(i),eps,den
c1045  format(1x,i5,7f10.4)
      enddo
      r1=100.*eps/den
      write(ncwu,1000) r1
1000  format(/,' R(Inter) =',f10.2)
      endif
c--	enddo
      return
      end
c
code for newpar
      subroutine newpar(kk,r1)
c--calculate the cruickshank's coeficents by l.s. analysis of /Fo-Fc/^2
c--
      include 'li6com.inc'
c
      common/lst04/iw4,l4,m4,n4
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      character*60 carctr,ifmt
      common/cfile/ carctr,ifmt
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      dimension cod(30)
      equivalence(icod,cod)
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      dimension det(3,3),vet(3),nre(20),rre(20),vetdum(3,3)
      dimension norrif(1001),fo(2,1001),sd2w(1000),ffo(1000)
c--
c      write(ncwu,*)' entro in NewPar'
c      scalo=1.0/abs(store(l5o))
c      scalc=1.0
      scalc=abs(store(l5o))
      scalo=1.0
c--
      jfirst=0
      intervx=1000
      ninterx=20
      interv=0
      if(icod(3).ne.8) interv=icod(3)
c--	do kk=1,2
      if(kk.eq.1) then
      njump=3
      else
      m6=lxxe
      do i=1,nxxe
      st=sntl2(in)
      store(m6+7)=1.0/sqrt(st)
      m6=m6+md6d
      enddo
      njump=7
      endif
      call sortz(lxxe,nxxe,mdxxe,njump)
      call folimi(jfirst,interv,intervx,ninterx,norrif,fo,kk)
      jfirst=1
c      write(ncwu,*)'interv:',interv
      do i=1,3
      vet(i)=0.0
      do j=1,3
      det(i,j)=0.0
      enddo
      enddo
      m6=lxxe
      st=0.0
      do i=1,interv
      iniz=norrif(i)
      ifin=norrif(i+1)-1
c      write(ncwu,*)'iniz,ifin,kki,i',iniz,ifin,kk,i
      sd2w(i)=0.
      ffo(i)=0.
      do k=iniz,ifin
      st=store(m6+7)
      fobs=store(m6+3)*scalo
      sigma=store(m6+4)*scalo
      fcal=store(m6+5)*scalc
c      ih=store(m6  )
c      ik=store(m6+1)
c      il=store(m6+2)
c      write(ncwu,7520)ih,ik,il,fobs,sigma,fcal,st
7520  format(1x,3i4,4f10.3)
      diff=fobs-fcal
      diff2=diff*diff
      sd2w(i)=sd2w(i)+diff2
c--definisco la variabile
      if(kk.eq.1) then
      variab=fobs
      else
      variab=st
      endif
      ffo(i)=ffo(i)+variab
c      write(ncwu,*)'st,ffo',st,ffo(i),diff2,sd2w(i)
c--calculate the coefficients of the function:
c  utilizzando i valori di ogni riflesso 
c  d2 = a + b*F + c*F2	  case kk=1
c  d2 = a + b*st+ c*st2   case kk=2
c  by the ls methods
c      det(1,1)=det(1,1)+1
c      det(1,2)=det(1,2)+variab
c      det(1,3)=det(1,3)+variab*variab
c      vet(1)=vet(1)+diff2
c      det(2,2)=det(2,2)+variab*variab
c      det(2,3)=det(2,3)+variab*variab*variab
c      vet(2)=vet(2)+diff2*variab
c      det(3,3)=det(3,3)+variab*variab*variab*variab
c      vet(3)=vet(3)+diff2*variab*variab
      m6=m6+md6d
      enddo
      contrib=float(ifin-iniz+1)
      sd2w(i)=sd2w(i)/contrib
      ffo(i)=ffo(i)/contrib
c      write(ncwu,*)'i,sd2w(i),ffo(i),contrib:',i,sd2w(i),ffo(i),contrib
      enddo
c--calculate the coefficients of the function:
c  utilizzando i valori medi
c  d2 = a + b*F + c*F2	  case kk=1
c  d2 = a + b*st+ c*st2   case kk=2
c  by the ls methods
      do i=1,interv
      det(1,1)=det(1,1)+1
      det(1,2)=det(1,2)+ffo(i)
      det(1,3)=det(1,3)+ffo(i)*ffo(i)
      vet(1)=vet(1)+sd2w(i)
      det(2,2)=det(2,2)+ffo(i)*ffo(i)
      det(2,3)=det(2,3)+ffo(i)*ffo(i)*ffo(i)
      vet(2)=vet(2)+sd2w(i)*ffo(i)
      det(3,3)=det(3,3)+ffo(i)*ffo(i)*ffo(i)*ffo(i)
      vet(3)=vet(3)+sd2w(i)*ffo(i)*ffo(i)
      enddo
      det(2,1)=det(1,2)
      det(3,1)=det(1,3)
      det(3,2)=det(2,3)
c--risoluzione del sistema delle eq. normali
	ider=3
	nvet=1
	do i=1,3
	vetdum(i,nvet)=vet(i)
	enddo
	call matin(det,ider,vetdum,nvet,deter)
	do i=1,3
	vet(i)=vetdum(i,nvet)
	enddo
c--controllo la equazione della parabola
c        write(ncwu,*)' vet...',vet(1),vet(2),vet(3)
c        xxx=-vet(2)/(2.0*vet(3))
c        yyy=vet(1)+vet(2)*xxx+vet(3)*xxx*xxx
c        write(ncwu,*)' xxx,yyy',xxx,yyy
c        if(yyy.lt.0) then
c        vet(1)=vet(1)-yyy+0.1
c        endif
c--save new coefficients in list 4
	do i=nfl,nfl+20
	store(i)=0.0
	enddo
	call xxcln(4)
	l=nfl+5
	store(l)=iw4
	store(l+1)=n4
	l4=l+2
c      store(l4	)=abs(vet(1))
c      store(l4+1)=abs(vet(2))
c      store(l4+2)=abs(vet(3))
      store(l4	)=vet(1)
      store(l4+1)=vet(2)
      store(l4+2)=vet(3)
      n=20
      call xfrml(4,n)
      call xfl04
c      write(ncwu,*)' new:', store(l4),store(l4+1),store(l4+2)
c--calculate r(w) indices
      if(icod(7).ge.1) then
      eps=0.
      den=0
      nchg=0
      n4z=0
      do i=1,interv
      fobs=ffo(i)
      if(iw4.eq.15) st=1.0/ffo(i)
      diff=sqrt(sd2w(i))
      sigmaf=0.0
c      write(ncwu,*)' i,fobs,fcal,sigmaf,st,diff',
c     1  i,fobs,fcal,sigmaf,st,diff
      call sweig(fobs,fcal,sigmaf,st,diff,w,n4z)
c      write(ncwu,*)' i,st,diff,w',i,st,diff,w
      w3=w*w
      w2=0.0
      if(w3.gt.0.0) w2=1.0/w3
      eps=eps+abs(sd2w(i)-w2)
      den=den+sd2w(i)
      ww=w3*sd2w(i)
c      write(ncwu,1046) ffo(i),w2,sd2w(i)
c1046  format(1x,7f10.4)
c      write(ncwu,1045) i,w3,w2,sd2w(i),ww,ffo(i),eps,den
c1045  format(1x,i5,7f10.4)
      enddo
      r1=100.*eps/den
      write(ncwu,1000) r1
1000  format(/,' R(Inter) =',f10.2)
      endif
c--	enddo
      return
      end
c
code for Chepar
      subroutine Chepar(kk,r1)
c--calculate the Chebyshev's coeficents by analysis of /Fo-Fc/^2
c--
      include 'li6com.inc'
c
      common/lst04/iw4,l4,m4,n4
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      character*60 carctr,ifmt
      common/cfile/ carctr,ifmt
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      dimension cod(30)
      equivalence(icod,cod)
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      common /xlst11/ l11r,m11r,md11r,n11r,l11s,m11s,md11s,n11s
      common /xlim11/ nfld,lfld,nld
      common /xdat11/ xstr11(700000)
      double precision str11(350000)
      equivalence(str11,xstr11)
c
      dimension norrif(1001),fo(2,1001),sd2w(1000),ffo(1000)
c--
c      scalo=1.0/abs(store(l5o))
c      scalc=1.0
      scalc=abs(store(l5o))
      scalo=1.0
c--
      jfirst=0
      intervx=1000
      ninterx=20
      interv=0
      if(icod(3).ne.8) interv=icod(3)
      njump=3
      call sortz(lxxe,nxxe,mdxxe,njump)
      call folimi(jfirst,interv,intervx,ninterx,norrif,fo,kk)
      jfirst=1
c--set some address
      md4=n4
      nu=nfld
      nr=nu+md4
      nv=nr-1
      ns=nr+md4*md4
      nz=ns+md4
      nfld=nz+md4
      do i=nu,nfld
	str11(i)=0.0
      enddo
c--start the reflections loop
      e=store(l4+10)
c      write(ncwu,*)'e:',e
      cs=2.
      ew=1.0/(e**cs)
      m6=lxxe
      do i=1,nxxe
	st=store(m6+7)
	fobs=store(m6+3)*scalo
	fcal=store(m6+5)*scalc
	diff=fobs-fcal
	diff2=diff*diff
	g=2.0*fobs*e-1
	str11(nu )=1.0
	str11(nu+1)=dble(g)
	nq=nu+2
	do l=3,md4
	  str11(nq)=2*g*str11(nq-1)-str11(nq-2)
	  nq=nq+1
	enddo
c	w=1.
c	w=ew
	w=ew/(1.+fobs**cs)
c	write(ncwu,*)fobs,fcal,diff2,w,str11(nu),str11(nu+1),
c     1	 str11(nu+2),str11(nu+3),str11(nu+4)
	nq=nr
	np=ns
	do l=nu,nv
	 do m=l,nv
	  str11(nq)=str11(nq)+str11(l)*str11(m)*dble(w)
	  nq=nq+1
	 enddo
	 str11(np)=str11(np)+str11(l)*dble(diff2*w)
	 np=np+1
	enddo
	m6=m6+md6d
      enddo
c
c--invert the current block
      if(istat2-1) 2012,2012,2013
2013  continue
      kd=1
      jf=md4
      js=nr
      jz=nz
      jv=ns
      write(ncwu,2021) kd,jf,js,jz
2021  format(//,' block no.',i3,' ; matrix order =',
     1 i4,' ; 1 elem. address =',i5,' ; work space address =',
     2 i5,/)
      iii=jf-1
      iv=js
      do 2022 ivi=1,jf
      write(ncwu,2023)(str11(ivv),ivv=iv,iv+iii)
2023  format(1x,10e12.4)
      iv=iv+iii+1
      iii=iii-1
2022  continue
      write(ncwu,2023)(str11(ivv),ivv=jv,jv+jf-1)
2012  continue
c
c--calculate the coefficients of the function:
      if(jchol(md4,nr,nz)) 3010,2000,3010
2000  continue
      call xsolv(md4,nr,ns,nz)
c--save new coefficients in list 4
	do i=nfl,nfl+20
	store(i)=0.0
	enddo
	call xxcln(4)
	l=nfl+5
	store(l)=iw4
	store(l+1)=n4
	l4=l+2
	l=l4
	do n=1,n4
	 store(l)=str11(nz)
	 l=l+1
	 nz=nz+1
	enddo
	store(l4+10)=e
	n=20
	call xfrml(4,n)
	call xfl04
c      write(ncwu,*)' new(1):', store(l4),store(l4+1),store(l4+2)
c     1 ,store(l4+3),store(l4+4),store(l4+10)
c--calculate r(w) indices
      if(icod(7).ge.1) then
      m6=lxxe
      eps=0.
      den=0
      nchg=0
      n4z=0
      do i=1,interv
      iniz=norrif(i)
      ifin=norrif(i+1)-1
c      write(ncwu,*)'iniz,ifin,kki,i',iniz,ifin,kk,i
      sd2w(i)=0.
      ffo(i)=0.
      do k=iniz,ifin
      st=store(m6+7)
      fobs=store(m6+3)*scalo
      sigma=store(m6+4)*scalo
      fcal=store(m6+5)*scalc
c      ih=store(m6  )
c      ik=store(m6+1)
c      il=store(m6+2)
c      write(ncwu,7520)ih,ik,il,fobs,sigma,fcal,st
7520  format(1x,3i4,4f10.3)
      diff=fobs-fcal
      diff2=diff*diff
      sd2w(i)=sd2w(i)+diff2
      ffo(i)=ffo(i)+fobs
c      write(ncwu,*)'st,ffo',st,ffo(i),diff2,sd2w(i)
      m6=m6+md6d
      enddo
      contrib=float(ifin-iniz+1)
      sd2w(i)=sd2w(i)/contrib
      ffo(i)=ffo(i)/contrib
c      write(ncwu,*)'i,sd2w(i),ffo(i),contrib:',i,sd2w(i),ffo(i),contrib
      fobs=ffo(i)
      diff=sqrt(sd2w(i))
      sigmaf=0.0
c      write(ncwu,*)' i,fobs,fcal,sigmaf,st,diff',
c     1  i,fobs,fcal,sigmaf,st,diff
      call sweig(fobs,fcal,sigmaf,st,diff,w,n4z)
c      write(ncwu,*)' i,st,diff,w',i,st,diff,w
      w3=w*w
      w2=0.0
      if(w3.gt.0.0) w2=1.0/w3
      eps=eps+abs(sd2w(i)-w2)
      den=den+sd2w(i)
      ww=w3*sd2w(i)
c      write(ncwu,1046) ffo(i),w2,sd2w(i)
c1046  format(1x,7f10.4)
c      write(ncwu,1045) i,w3,w2,sd2w(i),ww,ffo(i),eps,den
c1045  format(1x,i5,7f10.4)
      enddo
      r1=100.*eps/den
      write(ncwu,1000) r1
1000  format(/,' R(Inter) =',f10.2)
      endif
      return
3010  continue
      write(ncwu,*)' Warning!'
      return
      end
c
code for folimi
      subroutine folimi(jfirst,interv,intervx,ninterx,norrif,fo,kk)
c--calculate the range limits
c--
      include 'li6com.inc'
c
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension norrif(1001),fo(2,1001)
c
      if(jfirst.eq.0)then
      if(interv.ne.0)then
	ninter=nxxe/interv
      else
	interv=8
150	continue
	if(interv.lt.intervx) then
	   ninter=nxxe/interv
	   if(ninter.gt.ninterx)then
	     interv=interv+1
	     goto 150
	   endif
	endif
      endif
      ninter=nxxe/interv
      nrest=nxxe-(ninter*interv)
c--calculate the limits of the intervals
      norrif(1)=1
      norrif(interv+1)=nxxe+1
      endif
c--fo o sin(theta)/labmda
      if(kk.eq.1)then
       fo(kk,1)=store(lxxe+3)
       fo(kk,interv+1)=store(lxxe+3+(nxxe-1)*md6d)
       m6=lxxe+md6d+3
      else
       fo(kk,1)=store(lxxe+7)
       fo(kk,interv+1)=store(lxxe+7+(nxxe-1)*md6d)
       m6=lxxe+md6d+7
      endif
      do i=2,interv
	if(jfirst.eq.0) then
	  ninte=ninter
	  if(i.le.nrest)ninte=ninter+1
	  norrif(i)=norrif(i-1)+ninte
	else
	  ninter=norrif(i)-norrif(i-1)
	endif
	m6=m6+md6d*ninter
	fo(kk,i)=store(m6)
      enddo
c      write(ncwu,*)' interv ',ninter,(norrif(i),i=1,interv+1)
c      write(ncwu,*)' interv ',ninter,(fo(kk,i),i=1,interv+1)
      return
      end
c
code for xweight
      subroutine xweight(wrob)
c--cruickshank's coeficents automatic determination 
c--
      include 'li6com.inc'
c
      common/lst04/iw4,l4,m4,n4
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      character*60 carctr,ifmt
      common/cfile/ carctr,ifmt
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      dimension cod(30)
      equivalence(icod,cod)
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension aa(3)
c--
c      write(ncwu,*) ' entro in xweight'
c      scalo=1.0/abs(store(l5o))
c      scalc=1.0
      scalc=abs(store(l5o))
      scalo=1.0
c
c--set some code
      if(iw4.eq. 1) icod(15)=0
      if(iw4.eq. 2) then
       if(icod(21).eq.0) icod(21)=1
      endif
      if(iw4.eq. 3) icod(15)=0
      if(iw4.eq. 4) icod(15)=0
      if(iw4.eq. 5) icod(15)=0
      if(iw4.eq. 6) icod(15)=0
      if(iw4.eq. 7) icod(15)=0
      if(iw4.eq. 8) icod(15)=0
      if(iw4.eq. 9) icod(15)=0
      if(iw4.eq.10) icod(15)=0
      if(iw4.eq.11) then
       if(icod(21).eq.0) icod(21)=1
      endif
      if(iw4.eq.12) then
       if(icod(21).eq.0) icod(21)=1
       if(icod(24).eq.1) icod(15)=0
      endif
      if(iw4.eq.13) then
       if(icod(21).eq.0) icod(21)=1
      endif
      if(iw4.eq.14) icod(15)=0
      if(iw4.eq.15) icod(15)=0
      if(iw4.eq.16) icod(15)=0
      if(iw4.eq.17) icod(15)=0
      if(iw4.eq.18) icod(15)=0
c--
      if(iw4.eq.12) then
       if(icod(24).eq.1) call wshelx(r1)
      endif
      if(iw4.eq.14) then
       kk=1
       call newpar(kk,r1)
      endif
      if(iw4.eq.15) then
       kk=2
       call newpar(kk,r1)
       m6=lxxe
       do i=1,nxxe
       st=sntl2(in)
       store(m6+7)=sqrt(st)
       m6=m6+md6d
       enddo
      endif
      if(iw4.eq.16) then
       kk=1
       call Chepar(kk,r1)
      endif
c--
c      write(ncwu,*)' new(w):', store(l4),store(l4+1),store(l4+2)
c     1 ,store(l4+3),store(l4+4),store(l4+10)
      d2wt1=0.
      m6=lxxe
      nchg=0
      n4z=0
      sumdif=0.0
      sumw=0.0
      do i=1,nxxe
      fobs=store(m6+3)*scalo
      fcal=store(m6+5)*scalc
      diff=abs(fobs-fcal)
      diff2=diff*diff
      st=store(m6+7)
      sigmaf=store(m6+4)*scalo
      call sweig(fobs,fcal,sigmaf,st,diff,w1,n4z)
      w2=w1*w1
      d2w=diff2*w2
c      sumdif=sumdif+1.0/diff2
c      sumw=sumw+w2
      d2wt1=d2wt1+d2w
c      write(ncwu,*)'i,fobs,w2,diff2,d2w',i,fobs,w2,diff2,d2w
      m6=m6+md6d
      enddo
c--	d2wt1=d2wt1*scalo*scalo
c      write(ncwu,*)'1) nchg,n4z',nchg,n4z
      d2wt1=d2wt1/(nxxe-n22a)
      s=sqrt(d2wt1)
c      rap=sumdif/sumw
c      store(l4+n4)=rap
c      store(l4+n4)=1.0/d2wt1
      if(icod(7).ge.1)then
	write(ncwu,9314)
9314	format(1h ,78(1h-))
	write(ncwu,'(a)') ' Weighting scheme analysis '
	write(ncwu,'(a,/)') ' wd2 = SQRT( w*(Fo-Fc)^2 / Nref )'
      endif
c--determinazione dei nuovi coeff. della funzione di peso
c      write(ncwu,*)' iw4,d2wt1,nxxe,n22a',iw4,d2wt1,nxxe,n22a
c      if(icod(18).eq.0)then
c-----------1 2 3 4 5 6 7 8 9101112131415161718------------
c      goto(2,1,2,2,3,3,2,2,3,3,1,1,1,1,1,4,1,1),iw4
      if(iw4.eq.16) goto 4
      if(iw4.eq.2.or.iw4.ge.11) then
c       select case (iw4)
c        case (2,11,12,13,14,15,17,18)
c1       continue
	  m=l4
	  n=n4
	  if(iw4.eq.11.or.iw4.ge.17) n=n-1
	  do i=1,n
	   store(m)=store(m)*d2wt1
	   m=m+1
	  enddo
        endif
c          goto 4
c2       continue
      if(iw4.eq.1.or.iw4.eq.3.or.iw4.eq.4.or.iw4.eq.7.
     1 or.iw4.eq.8) then
c       case (1,3,4,7,8)
	  store(l4+n4)=store(l4+n4)/d2wt1
      endif
c          goto 4
c3       continue
      if(iw4.eq.5.or.iw4.eq.6.or.iw4.eq.9.or.iw4.eq.10) then
c       case (5,6,9,10)
	store(l4)=store(l4)/d2wt1
      endif
c      end select
4     continue
c      endif
c      write(ncwu,*)'1new(w):', store(l4),store(l4+1),store(l4+2)
c     1 ,store(l4+3),store(l4+4),store(l4+10)
      wfo2t=0.
      rwt=0.
      rt=0.
      fo1t=0.
      d2wt1=0.
      m6=lxxe
      nchg=0
      n4z=0
      do i=1,nxxe
      st=store(m6+7)
      fobs=store(m6+3)*scalo
      fcal=store(m6+5)*scalc
      diff=abs(fobs-fcal)
      diff2=diff*diff
      fobs2=fobs*fobs
      fo1t=fo1t+abs(fobs)
      sigmaf=store(m6+4)*scalo
      call sweig(fobs,fcal,sigmaf,st,diff,w1,n4z)
      w2=w1*w1
      d2w=diff2*w2
      d2wt1=d2wt1+d2w
c      wdf=w1*diff
c      write(ncwu,1)store(m6),store(m6+1),store(m6+2),
c     2 fobs,fcal,diff,w1,wdf,d2wt1
c1     format(1x,3f6.0,6f10.3)
      wfo2t=wfo2t+fobs2*w2
      rwt=rwt+d2w
      rt=rt+abs(diff)
      m6=m6+md6d
      enddo
c--	d2wt1=d2wt1*scalo*scalo
c      write(ncwu,*)'2) nchg,n4z',nchg,n4z
c      write(ncwu,'(f10.3,2i10,2f10.5)') d2wt1,nxxe,n22a,scalo,scalc
      d2wt1=d2wt1/(nxxe-n22a)
      s=sqrt(d2wt1)
      rt=100.*rt/fo1t
      rwt=100.*sqrt(rwt/wfo2t)
      if(icod(7).ge.1) then
      write(ncwu,9315) rt
9315  format(' R(F)%........',f7.3)
      write(ncwu,9316) rwt
9316  format(' wR(F^2)%.....',f7.3)
      write(ncwu,8000)s
8000  format(' S (G.o.F.)...',f7.3)
      end if
      if(iw4.ne.16) then
	do i=nfl,nfl+20
	store(i)=0.0
	enddo
      call xxcln(4)
      l=nfl+5
      store(l  )=iw4
      store(l+1)=n4
c     if(iw4.gt.8) goto 2
c     goto(1,2,1,1,2,2,1,1),iw4
c1    continue
      if(iw4.eq.1.or.iw4.eq.3.or.iw4.eq.4.or.iw4.eq.7
     1		 .or.iw4.eq.8) then
c      select case (iw4)
c       case (1,3,4,7,8)
	n4=n4+1
c      end select
      endif
c2    continue
      if(n4.gt.0) then
      m4=l4
      do j=1,n4
      store(l+1+j)=store(m4)
      m4=m4+1
      enddo
      else
      store(l+2)=store(l4)
      endif
      n=20
      call xfrml(4,n)
       ipr=0
c      if(icod(7).eq.1) call sw04(ipr)
      call xfl04
      endif
c      write(ncwu,*)' new(2):', store(l4),store(l4+1),store(l4+2)
c     1 ,store(l4+3),store(l4+4),store(l4+10)
c--calculate weight
      call calcoe
      call xfl04
c      write(ncwu,*)' new(3):', store(l4),store(l4+1),store(l4+2)
c     1 ,store(l4+3),store(l4+4),store(l4+10)
c--calculate r(w) indices
      if(icod(7).ge.1) then
      njump=3
      call sortz(lxxe,nxxe,mdxxe,njump)
      eps=0.
      den=0.
      m6=lxxe
      if(istat2.ge.1) then
      write(ncwu,1030)
1030  format(/,' List of reflections with (d2-w)/d2',
     1 ' greather than 80%',/)
      write(ncwu,1035)
1035  format(4x,'reflection',6x,'fo',6x,'fc',
     2 5x,'diff2',3x,'weight',3x,'W(new)',2x,'snt/l',/)
      endif
      nchg=0
      wrob=0.0
      n4z=0
      do i=1,nxxe
      fobs=store(m6+3)*scalo
      fcal=store(m6+5)*scalc
      diff=abs(fobs-fcal)
      diff2=diff*diff
      sigmaf=store(m6+4)*scalo
      st=store(m6+7)
      call sweig(fobs,fcal,sigmaf,st,diff,w1,n4z)
      wrob=wrob+w1*abs(diff)
      w3=w1*w1
      d2w=diff2*w3
      w2=0.0
      if(w3.gt.0.0) w2=1.0/w3
      diff3=diff2-w2
      eps=eps+abs(diff3)
      diff4=diff2
      if(diff3.lt.0.0) diff4=w2
      den=den+diff4
c      write(ncwu,1045) i,w3,w2,diff2,diff3,eps,den
c1045  format(1x,i5,4f10.4,2f15.5)
      if(istat2.ge.1) then
       write(ncwu,1040)(store(m),m=m6,m6+2),fobs,fcal ,
     1	diff2,w2,w3,store(m6+7)
1040   format(3f5.0,2f8.2,3f8.3,f8.4)
      endif
      m6=m6+md6d
      enddo
      wrob=wrob/nxxe
      r2=100.*eps/den
      write(ncwu,1010) nchg,n4z,r2,wrob
1010  format(/,' Weight(s) modified      ',i8,/,
     1	       ' Weight(s) set to random ',i8,/,
     1	       ' R(all)        =',f10.2,/,
     1	       ' <|sqrt(w).D|> =',f10.3,/)
      write(ncwu,9314)
      endif
      return
      end
c
code for calcoe
      subroutine calcoe
c--cruickshank's coeficents automatic determination 
c--
      include 'li6com.inc'
c
      common/lst04/iw4,l4,m4,n4
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/funit/ncfu(9),nfon(9)
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      dimension cod(30)
      equivalence(icod,cod)
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension sd2w(1000),der(1000,3),aa(3),norrif(1001),
     1 vet(3),fo(2,1001),vetdum(3,3)
      dimension dprint(1000,11)
      dimension aap(50,3),adum(4),sdum(4)
      dimension det(3,3)
c
c      write(ncwu,*) ' entro in calcoe'
c--ninter n.di rifl. per intervallo
c--interv n. di intervalli
c--scale of /fo/
c      scalo=1.0/abs(store(l5o))
c      scalc=1.0
      scalc=abs(store(l5o))
      scalo=1.0
c--
      ncicli=icod(2)
      ncicli1=icod(20)
      itype =icod(21)
      idivide=icod(18)
      errpsi=cod(4)
      ntent =icod(8)
      fudge =cod(5)
      ifud=int(fudge*10000.0)
c      psi=cod(6)
      icod3=icod(3)
      do j=1,50
      do i=1,3
      aap(j,i)=0.
      enddo
      enddo
      do i=1,3
      aa(i)=0.
      vet(i)=0.
      enddo
      do i=1,4
      adum(i)=0.
      sdum(i)=0.
      enddo
c
c--sort on Fo
      njump=3
      call sortz(lxxe,nxxe,mdxxe,njump)
      intervx=120
      ninterx=120
      interv=0
      if(icod3.ne.8) interv=icod3
      kk=1
      jfirst=0
      call folimi(jfirst,interv,intervx,ninterx,norrif,fo,kk)
      jfirst=1
c
c--sort on (sin(theta)/lambda)2
      njump=7
      call sortz(lxxe,nxxe,mdxxe,njump)
      kk=2
      call folimi(jfirst,interv,intervx,ninterx,norrif,fo,kk)
      if(icod(7).ge.1)then
	  write(ncwu,4201)
4201	  format(1h )
	  if(icod(15).eq.1) then
	  write(ncwu,'(a)')    ' Starting parameters'
	  else
	  write(ncwu,'(a)')    ' Weighting parameters'
	  endif
	  do i=1,n4
	  write(ncwu,4202) i,store(l4-1+i)
4202	  format(3h P(,i1,3h) =,f10.5)
	  enddo
      endif
c-------------------------------------
      nci1=1
1000  continue
      call wcho(ider,itype,idivide,aa,bbb)
      psi0=99999.
      iexit=0
      nci=1
c--start the loop
999   continue
      istampa=0
c      write(ncwu,*)'#########nci,iexit',nci,iexit
c      write(ncwu,*)'#########aa',aa(1),aa(2)
c--
c--write file autow.tst
c      write(ncpu,4601)nci,rrt,rrwt
c--
      if(icod(7).gt.1)then
	  if(icod(15).eq.1) then
	  write(ncwu,'(/,a,i3)') ' Cycle',nci
	  endif
      endif
      d2wmin=1000
      d2wmax=0.
      d2wt1=0.
c--considera distribuzione fo (kk=1) e sin(teta) (kk=2)
      interv2=interv*2
      do kk=1,icod(23)
      if(kk.eq.1) then
       interv2=interv
       incr=0
       njump=3
      else
       interv2=interv*2
       njump=7
       incr=interv
      endif
      call sortz(lxxe,nxxe,mdxxe,njump)
      if(icod(7).gt.1)then
	if(nci.eq.1.or.nci.eq.ncicli)then
c	   istampa=1
          if(kk.eq.1) then
          write(ncwu,4200)
4200	  format(/,' Range #',8x,'Nref',9x,' Fo Range',
     1	       9x,'  < wd2 > ')
	  else
	  write(ncwu,4207)
4207	  format(/,' Range #',8x,'Nref',4x,' Sin(theta)/l Range',
     1	       4x,'  < wd2 > ')
	  endif
	endif
      endif
      m6=lxxe
      nchg=0
      n4z=0
      do i=1,interv
      ii=i+incr
      iniz=norrif(i)
      ifin=norrif(i+1)-1
      sd2w(ii)=0.
      if(icod(15).eq.1) then
        do j=1,ider
	der(ii,j)=0.
        enddo
      endif
      do k=iniz,ifin
      st=store(m6+7)
      fobs=store(m6+3)*scalo
      fcal=store(m6+5)*scalc
      diff=abs(fobs-fcal)
      diff2=diff*diff
      sigmaf=store(m6+4)*scalo
      if(icod(15).eq.1) then
	icalc=1
	call wderiv(k,icalc,itype,aa,bbb,ii,der,scalo,scalc,d2w)
      else
	call sweig(fobs,fcal,sigmaf,st,diff,w1,n4z)
        w2=w1*w1
	d2w=diff2*w2
      endif
      sd2w(ii)=sd2w(ii)+d2w
      m6=m6+md6d
      enddo
      contrib=float(ifin-iniz+1)
      icont=int(contrib)
      sd2w(ii)=sd2w(ii)/contrib
      d2wt1=d2wt1+sd2w(ii)
      ww=sd2w(ii)
      if(icod(15).eq.1) then
	do l=1,ider
	der(ii,l)=der(ii,l)/contrib
	enddo
c--divido per P(2) per essere in scala con S calcolato precedentemente
	if(idivide.eq.0) then
	  goto (1110,1120,1130,1135),itype
1110	  continue
	  ww=sd2w(ii)/store(l4+1)
          goto 1140
1120	  continue
	  ww=sd2w(ii)/store(l4+2)
          goto 1140
1130	  continue
	  ww=sd2w(ii)/store(l4)
	  goto 1140
1135	  continue
	  ww=sd2w(ii)/store(l4+3)
1140	  continue
	endif
      endif
      if(ww.lt.d2wmin)d2wmin=ww
      if(ww.gt.d2wmax)d2wmax=ww
      if(icod(7).gt.1)then
	if(nci.eq.1.or.nci.eq.ncicli) then
	 if(kk.eq.1) then
	  write(ncwu,3001)i,icont,(fo(kk,jj),jj=i,i+1),ww
3001	  format(i5,i15,6x,f5.1,' - ',f5.1,f17.5)
	 else
	  write(ncwu,3002)ii,icont,(fo(kk,jj),jj=i,i+1),ww
3002	  format(i5,i15,5x,f6.4,' - ',f6.4,f16.5)
	 endif
       endif
      endif
c--write file 'structure'.num
       fom=0.5*(fo(kk,i+1)+fo(kk,i))
c      write(ncpu,4600)fom,ww
       dprint(ii,1)=fom
       dprint(ii,nci+1)=ww
c--
c--fine loop intervalli
      enddo
c--fine analisi distribuzioni
      enddo
c--
4600  format(1x,11f10.4)
4601  format(1x,i10,2f10.4)
      d2wt1=d2wt1/float(interv2)
c      write(ncwu,*)'d2wt1',d2wt1
c--determinazione della media (sm)
      if(cod(22).gt.0.1) then
	 d2wm=cod(22)
      else
      if(nci.eq.1)then
	d2wm=0.
	do j=1,interv2
c	write(ncwu,*) d2wm,sd2w(j)
	d2wm=d2wm+sd2w(j)
	enddo
c	write(ncwu,*) interv2
	d2wm=d2wm/float(interv2)
c	write(ncwu,*)'d2wm',d2wm
	d2wm5=d2wm*0.5
	d2wm1=d2wm-d2wm5
	d2wm2=d2wm+d2wm5
	d2wmi=0.0
	nmed=0
	do j=1,interv2
c	write(ncwu,*) j,d2wm2,d2wm1,d2wmi,sd2w(j)
	if((sd2w(j).le.d2wm2).and.(sd2w(j).ge.d2wm1)) then
	d2wmi=d2wmi+sd2w(j)
	nmed=nmed+1
	endif
	enddo
	if(nmed.eq.0) then
	 write(ncwu,3101)
3101	 format(/,' Warning: bad fo-distribution!')
c     1 ' weighting scheme analisys terminated.')
c         return
c         endif
        else
	 d2wm=d2wmi/float(nmed)
c	 write(ncwu,*)'d2wm, d2wmi,nmed',d2wm, d2wmi,nmed
        endif
      endif
      endif
      if(icod(15).eq.1) then
	do i=1,ider
	 vet(i)=0.
	enddo
       endif
c      write(ncwu,*)' icod(15),nci',icod(15),nci
      if(nci.eq.1.and.icod(15).eq.0) goto 3500
      if(iexit.eq.1)goto 3500
      if(icod(15).eq.1) then
c-- calcolo dei coeff.del sistema lineare
	do i=1,ider
	 vet(i)=0.
	 do  k=1,ider
	  det(i,k)=0.
	 enddo
	enddo
	do j=1,interv2
	 do i=1,ider
	  vet(i)=vet(i)+der(j,i)*(d2wm-sd2w(j))
	  do k=1,ider
	   det(i,k)=det(i,k)+der(j,i)*der(j,k)
	  enddo
	 enddo
	enddo
c--risoluzione del sistema delle eq. normali
	nvet=1
	do i=1,3
	vetdum(i,nvet)=vet(i)
	enddo
	call matin(det,ider,vetdum,nvet,deter)
	do i=1,3
	vet(i)=vetdum(i,nvet)
	enddo
      end if
c--calcolo della funzione da minimizzare
3500  continue
      psi=0.0
      do j=1,interv2
       e=d2wm-sd2w(j)
       psi=psi+e*e
c      write(ncwu,*)'j, nci,psi ',j,nci,psi
      enddo
      scarto2=sqrt(psi/interv2)
      d2ww=d2wm
c	write(ncwu,*)' idivide,itype',idivide,itype
	if(idivide.eq.0) then
	  goto (1111,1121,1131,1132),itype
1111	  continue
	  d2ww=d2wm/store(l4+1)
	  goto 1141
1121	  continue
	  d2ww=d2wm/store(l4+2)
	  goto 1141
1131	  continue
	  d2ww=d2wm/store(l4)
	  goto 1141
1132	  continue
	  d2ww=d2wm/store(l4+3)
1141	  continue
	endif
      diffx=100.0*scarto2/d2ww
      diff=100.0*(d2wmax-d2wmin)/d2ww
      if(icod(15).eq.1) then
      if(iexit.eq.0) then
c--determinazione degli shift da applicare
      do k=1,ider
5110  continue
      if(vet(k).lt.-aa(k)) then
	vet(k)=vet(k)/2
	goto 5110
      end if
c5110  continue
c      if(abs(vet(k)).gt.aa(k)) then
c	vet(k)=vet(k)/2
c	goto 5110
c      end if
      enddo
      endif
      endif
      if(icod(7).gt.1)then
	 write(ncwu,4201)
	 goto (3011,3012,3013,3015),itype
3011	 continue
	 adum(1)=aa(1)
	 adum(2)=bbb
	 adum(3)=aa(2)
	 adum(4)=aa(3)
	 sdum(1)=vet(1)
	 sdum(2)=0.0
	 sdum(3)=vet(2)
	 sdum(4)=vet(3)
	 goto 3014
3012	 continue
	 adum(1)=aa(1)
	 adum(2)=aa(2)
	 adum(3)=bbb
	 adum(4)=aa(3)
	 sdum(1)=vet(1)
	 sdum(2)=vet(2)
	 sdum(3)=0.0
	 sdum(4)=vet(3)
	 goto 3014
3013	 continue
	 adum(1)=bbb
	 adum(2)=aa(1)
	 adum(3)=aa(2)
	 adum(4)=aa(3)
	 sdum(1)=0.0
	 sdum(2)=vet(1)
	 sdum(3)=vet(2)
	 sdum(4)=vet(3)
	 goto 3014
3015	 continue
	 adum(1)=aa(1)
	 adum(2)=aa(2)
	 adum(3)=aa(3)
	 adum(4)=bbb
	 sdum(1)=vet(1)
	 sdum(2)=vet(2)
	 sdum(3)=vet(3)
	 sdum(4)=0.0
3014	 continue
	j3=3
	if(iw4.eq.13) j3=4
	do j=1,j3
	 write(ncwu,4205) j,adum(j),j,sdum(j)
4205     format(' p(',i1,') =',f10.5,'  shift(',i1,') =',f10.5)
        enddo
	 write(ncwu,4203)d2wmin,d2wmax,d2ww,diff,scarto2,diffx
4203	 format(' Min. < wd2 >      = ',f10.5,
     1	 /,	' Max. < wd2 >      = ',f10.5,
     1	 /,	' Average <wd2>     = ',f10.5,
     1	 /,	' Difference in %   = ',f10.5,
     1	 /,	' Scarto quad.medio = ',f10.5,
     1	 /,	' Scarto relativo % = ',f10.5)
c         if(nci.eq.1.or.nci.eq.ncicli)then
c	   write(ncwu,4204)d2ww
c4204	   format(' Fixed < wd2 >    = ',f10.5)
c         endif
	 if(icod(15).eq.1) then
	  write(ncwu,3506)psi
3506	  format(' Minim. Function   = ',e15.5)
         endif
      endif
      if(iexit.eq.1) goto 5200
      if(icod(15).eq.0) goto 5500
c--determinazione dei nuovi coeff. della funzione di peso
      do i=1,ider
      aap(nci,i)=aa(i)
      enddo 
      do k=1,ider
      aa(k)=aa(k)+vet(k)*fudge
      enddo
c--analisi dell'affinamento
c      write(*,*)'analisi',psi0,errpsi
      difpsi=psi0-psi
c      write(ncwu,*)' nci,ncicli,difpsi,psi ',nci,ncicli,difpsi,psi
      if(difpsi.lt.0) goto 5101
      if(difpsi/psi.lt.errpsi) goto 5102 
      if(icod(15).eq.0) go to 5200
      if(nci.eq.ncicli)go to 5200
5105  continue
      nci=nci+1
      psi0=psi
      go to 999
5101  continue
      ncip=nci-1
      if(ncip.le.0)ncip=1
      do i=1,ider
      aa(i)=aap(ncip,i)
      enddo
5102  continue
      iexit=1
      ncicli=nci+1
      goto 5105
c--end of calculation
5200  continue
      if(icod(15).eq.1) then
      if(nfon(2).eq.1) then
       ncfuc=ncfu(2)
       do ii=1,interv2
	write(ncfuc,4600)dprint(ii,1),(dprint(ii,j),j=2,ncicli+1)
       enddo
      endif
      endif
c--
c      d2wt1=0.
c      m6=lxxe
c      do 6000 i=1,nxxe
c	icalc=0
c	call wderiv(i,icalc,itype,aa,bbb,ii,der,scalo,scalc,d2w)
c      d2wt1=d2wt1+d2w
c6000  m6=m6+md6d
c      d2wt1=d2wt1/(nxxe-n22a)
c      s=sqrt(d2wt1)
c--determinazione dei nuovi coeff. della funzione di peso
      bb=bbb
c      do 6100 k=1,ider
c6100  aa(k)=aa(k)*d2wt1
c      bb=d2wt1*bbb
      njump=3
      call sortz(lxxe,nxxe,mdxxe,njump)
      d2wt1=0.
      m6=lxxe
      do i=1,nxxe
	icalc=0
	call wderiv(i,icalc,itype,aa,bb,ii,der,scalo,scalc,d2w)
      d2wt1=d2wt1+d2w
      m6=m6+md6d
      enddo
c      write(ncwu,'(f10.3,2i10,2f10.5)') d2wt1,nxxe,n22a,scalo,scalc
      d2wt1=d2wt1/(nxxe-n22a)
      s=sqrt(d2wt1)
c--save new coefficients in list 4
	do i=nfl,nfl+20
	store(i)=0.0
	enddo
	call xxcln(4)
	l=nfl+5
	store(l)=iw4
	store(l+1)=n4
	l4=l+2
	goto (1041,1042,1043,1045),itype
1041    continue
      store(l4	)=aa(1)
      store(l4+1)=bb
      store(l4+2)=aa(2)
      if(iw4.eq.13) store(l4+3)=aa(3)
        goto 1044
1042    continue
      store(l4	)=aa(1)
      store(l4+1)=aa(2)
      store(l4+2)=bb
      if(iw4.eq.13) store(l4+3)=aa(3)
	goto 1044
1043    continue
      store(l4	)=bb
      store(l4+1)=aa(1)
      store(l4+2)=aa(2)
      if(iw4.eq.13) store(l4+3)=aa(3)
	goto 1044
1045	continue
      store(l4	)=aa(1)
      store(l4+1)=aa(2)
      store(l4+2)=aa(3)
      store(l4+3)=bb
1044	continue
      n=20
      call xfrml(4,n)
      call xfl04
      if(icod(15).eq.0) goto 5500
      nci1=nci1+1
      if(nci1.le.ncicli1) goto 1000
      if(icod(7).ge.1) then
	  write(ncwu,'(/,a)') ' Final parameters'
	  write(ncwu,1046) ncicli
1046	  format(' after',i3,' cycle(s)')
	  do i=1,n4
	  write(ncwu,4202) i,store(l4-1+i)
	  enddo
	  write(ncwu,8000)s
8000	  format(' S (G.o.F.) ',f7.3)
      endif
5500  continue
c--final tables
      if(icod(7).lt.1) return
      d2wmin=1000
      d2wmax=0.
      kk=1
      njump=3
5540  continue
      call sortz(lxxe,nxxe,mdxxe,njump)
      if(kk.eq.1) then
	  write(ncwu,5510)
5510	  format(//,' Analysis of <wd2> as a function of Fo')
	  write(ncwu,4200)
	  incr=0
      else
	  write(ncwu,5520)
5520	  format(//,' Analysis of <wd2> as a function of sin(T)/l)')
	  write(ncwu,4207)
	  interv2=2*interv
	  incr=interv
      endif
      m6=lxxe
      nchg=0
      n4z=0
c      write(ncwu,*)'iw4,n4,store(l4..l4+n4)',iw4,n4,
c     1 (store(i),i=l4,l4+n4)
      do i=1,interv
	ii=i+incr
	iniz=norrif(i)
	ifin=norrif(i+1)-1
	sd2w(ii)=0.
	do k=iniz,ifin
	  st=store(m6+7)
c	  write(ncwu,*)'i,k,sin(t)',i,k,store(m6+6)
	  fobs=store(m6+3)*scalo
	  fcal=store(m6+5)*scalc
	  diff=abs(fobs-fcal)
	  diff2=diff*diff
	  sigmaf=store(m6+4)*scalo
	  call sweig(fobs,fcal,sigmaf,st,diff,w1,n4z)
	  w2=w1*w1
	  d2w=diff2*w2
	  sd2w(ii)=sd2w(ii)+d2w
c--stampa parziale dei riflessi
c	  if(k.gt.1000.and.k.lt.1200) then
c	write(ncwu,*) 'k,diff2,w2,d2w,st,sd2w(ii)',
c     1	 k,diff2,w2,d2w,st,sd2w(ii)
c	  endif
c--fine stampa parziale
	  m6=m6+md6d
	enddo
	contrib=float(ifin-iniz+1)
	icont=int(contrib)
	sd2w(ii)=sd2w(ii)/contrib
	if(kk.eq.1) then
	write(ncwu,3001)ii,icont,(fo(kk,jj),jj=i,i+1),sd2w(ii)
	else
	write(ncwu,3002)ii,icont,(fo(kk,jj),jj=i,i+1),sd2w(ii)
	endif
	ww=sd2w(ii)
	if(ww.lt.d2wmin)d2wmin=ww
	if(ww.gt.d2wmax)d2wmax=ww
      enddo
      if(kk.eq.2) then
	d2wm=0.
	do j=1,interv2
c	 write(ncwu,*) d2wm,sd2w(j)
	 d2wm=d2wm+sd2w(j)
	enddo
	d2wm=d2wm/float(interv2)
c	write(ncwu,*)'d2wm',d2wm
	psi=0.0
	do j=1,interv2
	 e=d2wm-sd2w(j)
	 psi=psi+e*e
c	 write(ncwu,*)'j, nci,psi ',j,nci,psi
	enddo
	scarto2=sqrt(psi/interv2)
	d2ww=d2wm
	diffx=100.0*scarto2/d2ww
	diff=100.0*(d2wmax-d2wmin)/d2ww
	write(ncwu,4201)
	write(ncwu,4203)d2wmin,d2wmax,d2ww,diff,scarto2,diffx
	write(ncwu,3506)psi
	return
       else
c--sort on (sin(theta)/lambda)2
	njump=7
	kk=2
	goto 5540
      endif
      end
c
code for wcho
      subroutine wcho(ider,itype,idivide,aa,bbb)
c--definisco i coefficienti da affinare
c
      common/lst04/iw4,l4,m4,n4
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c
      dimension aa(3)
c
      ider=n4-1
c      select case (iw4)
      if(iw4.eq.2.or.iw4.eq.11) then
c       case(2,11)
c--criterio di pesaggio 2,11
	goto (1001,1002,1003),itype
1001    continue
        aa(1)= store(l4)
        aa(2)= store(l4+2)
        bbb  = store(l4+1)
	if(idivide.eq.0) then
	    aa(1)= store(l4)/store(l4+1)
	    aa(2)= store(l4+2)/store(l4+1)
	    bbb  = 1.0
	endif
        goto 1004
1002    continue
        aa(1)= store(l4)
        aa(2)= store(l4+1)
        bbb  = store(l4+2)
	if(idivide.eq.0) then
           aa(1)= store(l4)/store(l4+2)
           aa(2)= store(l4+1)/store(l4+2)
           bbb  = 1.0
        endif
        goto 1004
1003    continue
        aa(1)= store(l4+1)
        aa(2)= store(l4+2)
        bbb  = store(l4)
	if(idivide.eq.0) then
           aa(1)= store(l4+1)/store(l4)
           aa(2)= store(l4+2)/store(l4)
           bbb  = 1.0
        endif
1004  continue
      endif
c---------------------------------------
      if(iw4.eq.12) then
c      case (12)
c--criterio di pesaggio 12
	goto (1011,1012,1013),itype
1011	continue
        aa(1)= store(l4)
        aa(2)= store(l4+2)
        bbb  = store(l4+1)
	if(idivide.eq.0) then
           aa(1)= store(l4)/store(l4+1)
           aa(2)= store(l4+2)/store(l4+1)
           bbb  = 1.0
        endif
	goto 1014
1012	continue
        aa(1)= store(l4)
        aa(2)= store(l4+1)
        bbb  = store(l4+2)
	if(idivide.eq.0) then
           aa(1)= store(l4)/store(l4+2)
           aa(2)= store(l4+1)/store(l4+2)
           bbb  = 1.0
        endif
	goto 1014
1013	continue
	aa(1)= store(l4+1)
        aa(2)= store(l4+2)
        bbb  = store(l4)
	if(idivide.eq.0) then
           aa(1)= store(l4+1)/store(l4)
           aa(2)= store(l4+2)/store(l4)
           bbb  = 1.0
	endif
1014	continue
      endif
      if(iw4.eq.13) then
c       case(13)
c--criterio di pesaggio 13
	goto (1021,1022,1023,1025),itype
1021	continue
        aa(1)= store(l4)
        aa(2)= store(l4+2)
        bbb  = store(l4+1)
	aa(3)= store(l4+3)
	if(idivide.eq.0) then
	   aa(1)= store(l4  )/store(l4+1)
	   aa(2)= store(l4+2)/store(l4+1)
	   aa(3)= store(l4+3)/store(l4+1)
           bbb  = 1.0
        endif
	goto 1024
1022	continue
	aa(1)= store(l4  )
        aa(2)= store(l4+1)
        bbb  = store(l4+2)
	aa(3)= store(l4+3)
	if(idivide.eq.0) then
	   aa(1)= store(l4  )/store(l4+2)
           aa(2)= store(l4+1)/store(l4+2)
	   aa(3)= store(l4+3)/store(l4+2)
	   bbb	= 1.0
        endif
	goto 1024
1023	continue
        aa(1)= store(l4+1)
        aa(2)= store(l4+2)
	bbb  = store(l4  )
	aa(3)= store(l4+3)
	if(idivide.eq.0) then
           aa(1)= store(l4+1)/store(l4)
	   aa(2)= store(l4+2)/store(l4)
	   aa(3)= store(l4+3)/store(l4)
           bbb  = 1.0
        endif
	goto 1024
1025	continue
	aa(1)= store(l4  )
	aa(2)= store(l4+1)
	aa(3)= store(l4+2)
	bbb  = store(l4+3)
	if(idivide.eq.0) then
	   aa(1)= store(l4  )/store(l4+3)
	   aa(2)= store(l4+1)/store(l4+3)
	   aa(3)= store(l4+2)/store(l4+3)
           bbb  = 1.0
        endif
1024  continue
      endif
c---------------------------------------
c      end select
      return
      end
c
code for wderiv
      subroutine wderiv(k,icalc,itype,aa,bbb,ii,der,scalo,scalc,d2w)
c--calcola derivate
c--
      include 'li6com.inc'
c
      common/lst04/iw4,l4,m4,n4
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      dimension der(1000,3),aa(3)
c
      st=store(m6+7)
      fobs=store(m6+3)*scalo
      fcal=store(m6+5)*scalc
      diff=fobs-fcal
      diff2=diff*diff
      fobs2=fobs*fobs
      fodif2=diff2*fobs2
      fodif =diff2*fobs
      stdif =diff2*st
c      select case (iw4)
c--criterio di pesaggio 2
      if(iw4.eq.2.or.iw4.eq.11) then
c      case (2,11)
	goto (1011,1012,1013),itype
1011    continue
        w1=aa(1)+bbb*fobs+aa(2)*fobs2           
        goto 1014
1012    continue
        w1=aa(1)+aa(2)*fobs+bbb*fobs2           
        goto 1014
1013    continue
        w1=bbb+aa(1)*fobs+aa(2)*fobs2           
1014	continue
	if(iw4.eq.11) then
	  x=st**store(l4+3)
	  w11=w1
	  w1=w1/x
	endif
	d2w=diff2/w1
c--stampa parziale dei riflessi
c	if(k.le.20) then
c	write(ncwu,*) 'k,fobs,fcalc,diff,w1,d2w',
c     1	 k,fobs,fcal,diff,w1,d2w
c	endif
c--fine stampa parziale
c	if(icalc.eq.0) goto 1040
	if(icalc.gt.0) then
	if(iw4.eq.11) then
	  w2=x/(w11*w11)
	else
	  w2=1./(w1*w1)
	endif
	goto (1010,1020,1030),itype
1010	continue
	der(ii,1)=der(ii,1)-diff2 *w2
	der(ii,2)=der(ii,2)-fodif2*w2
	goto 1040
1020	continue
	der(ii,1)=der(ii,1)-diff2 *w2
	der(ii,2)=der(ii,2)-fodif *w2
	goto 1040
1030	continue
	der(ii,1)=der(ii,1)-fodif *w2
	der(ii,2)=der(ii,2)-fodif2*w2
1040	continue
       endif
      endif
c--criterio di pesaggio 12
      if(iw4.eq.12) then
c       case (12)
	sigma2=store(m6+4)*store(m6+4)
	goto (1111,1112,1113),itype
1111	continue
	w1=aa(1)*sigma2+bbb*fobs+aa(2)*fobs2
	goto 1114
1112	continue
	w1=aa(1)*sigma2+aa(2)*fobs+bbb*fobs2
	goto 1114
1113	continue
	w1=bbb*sigma2+aa(1)*fobs+aa(2)*fobs2
1114	continue
	d2w=diff2/w1
c	   write(ncwu,*) 'k,fobs,fcalc,diff,w1,d2w,sd2w(ii)',
c     1   k,fobs,fcal,diff,w1,d2w,sd2w(ii)
c	if(icalc.eq.0) goto 1140
	if(icalc.gt.0) then
	w2=1./(w1*w1)
	goto (1110,1120,1130),itype
1110	continue
	der(ii,1)=der(ii,1)-diff2 *w2*sigma2
	der(ii,2)=der(ii,2)-fodif2*w2
	goto 1140
1120	continue
	der(ii,1)=der(ii,1)-diff2 *w2*sigma2
	der(ii,2)=der(ii,2)-fodif *w2
	goto 1140
1130	continue
	der(ii,1)=der(ii,1)-fodif *w2
	der(ii,2)=der(ii,2)-fodif2*w2
1140	continue
       endif
      endif
c--criterio di pesaggio 13
      if(iw4.eq.13) then
c      case (13)
	goto (1211,1212,1213,1215),itype
1211	continue
	w1=aa(1)+bbb*fobs+aa(2)*fobs2+aa(3)*st
	goto 1214
1212	continue
	w1=aa(1)+aa(2)*fobs+bbb*fobs2+aa(3)*st
	goto 1214
1213	continue
	w1=bbb+aa(1)*fobs+aa(2)*fobs2+aa(3)*st
	goto 1214
1215	continue
	w1=aa(1)+aa(2)*fobs+aa(3)*fobs2+bbb*st
1214	continue
	d2w=diff2/w1
c	write(ncwu,*) 'k,fobs,fcalc,diff,w1,d2w,sd2w(ii)',
c      1   k,fobs,fcal,diff,w1,d2w,sd2w(ii)
c	if(icalc.eq.0) goto 1240
	if(icalc.gt.0) then
	w2=1./(w1*w1)
	goto (1210,1220,1230,1235),itype
1210	continue
	der(ii,1)=der(ii,1)-diff2 *w2
	der(ii,2)=der(ii,2)-fodif2*w2
	der(ii,3)=der(ii,3)-stdif *w2
	goto 1240
1220	continue
	der(ii,1)=der(ii,1)-diff2 *w2
	der(ii,2)=der(ii,2)-fodif *w2
	der(ii,3)=der(ii,3)-stdif *w2
	goto 1240
1230	continue
	der(ii,1)=der(ii,1)-fodif *w2
	der(ii,2)=der(ii,2)-fodif2*w2
	der(ii,3)=der(ii,3)-stdif *w2
	goto 1240
1235	continue
	der(ii,1)=der(ii,1)-diff2 *w2
	der(ii,2)=der(ii,2)-fodif *w2
	der(ii,3)=der(ii,3)-fodif2*w2
1240	continue
       endif
      endif
c     end select
      return
      end
c
code for agrdir
      subroutine agrdir(in)
c--read directives for agreement  routine routine
c
      character*80 itemp1
      character*60 carctr,ifmt
      common/cfile/ carctr,ifmt
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib(2),ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,ndd,ni,ntt,na(3),ncd,idoc(20)
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      dimension cod(30)
      equivalence(icod,cod)
      common/xtemp/itemp(80)
      dimension     temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
c$$-- 7-->8
      dimension itarg(10)
      character*40 iarg
      character*40 itst1
      character*4  ext
      dimension iclass(8),lkh(7),lkhgu(18),ifore(2)
c--
      data ifore/4hfo  ,4hreso/
      data iclass/4hggg ,4hggu ,4hgug ,4hguu ,4hugg ,4hugu ,
     1	4huug ,4huuu /
      data lkh/4hh00 ,4h0k0 ,4hhk0 ,4h00l ,4hh0l ,4h0kl ,
     1	4hhkl /
      data lkhgu/4hg00 ,4hu00 ,4h0g0 ,4h0u0 ,4hgk0 ,4huk0 ,
     1 4hhg0 ,4hhu0 ,4h00g ,4h00u ,4hg0l ,4hu0l ,4hh0g ,4hh0u ,
     1 4h0gl ,4h0ul ,4h0kg ,4h0ku /
c--                                                                     
      data itst1/'the file name !'/
      data iarg/'instruction(s) or ##'/
      data jnat/10/
      data itarg/4hnumb,
     2		 4hinte,
     3		 4hfo  ,
     4		 4hreso,
     5		 4hprin,
     6		 4hverb,
     7		 4hdump,
     8		 4happl,
     9		 4hsele,
     *		 4hend /
c$$------------------------------^
c-- set default values
      do i=1,30
       icod(i)=0
      enddo
      icod(3)=8
      cod(4)=-1.0
      cod(6)=0.0
      cod(7)=-1.0
      icod(8)=0
      if(idefa(i)) 1000,1000,9000
1000  continue
      call sty(iarg)
c
c--main loop for processing input instructions
c--fetch the next card
 2000 continue
      if(klnc(2)) 9000,2020,9000
c-- card to be interpreted
 2020 continue
      call xpcci
      if(jrca(itemp,n)) 2060,2040,2060
c--process the directive
 2040 continue
      n=kcomp(1,itemp,itarg,jnat,1)
      if(n) 2060,2060,2050
 2050 continue
c--	    /,2hnu,2hin,2hfo,2hre,2hpr,2hve,2hdu,2hap,2hse,
c--	      2hen/
      go to  (2200,2300,2400,2500,2600,2700,2800,2900,3000,
     1	      9000),n
c$$-------------------------------------------^
2060  continue
      call xunkw
      go to 2000
c
c--'number of reflection/interval' directive
2200  continue
      icod(2)=kredi(i)
c      if(icod(2).eq.0) icod(2)=0
      go to 2000
c
c--'interv' directive  (number of interval)
2300  continue
      icod(3)=kredi(i)
      if(icod(3).eq.0) icod(3)=8
      go to 2000
c
c--'fo ' directive (value of fo interval)
2400  continue
      if(jredf(temp,1)) 2060,2042,2042
2042  continue
      if(temp(1).eq.0.0) temp(1)=-1.0
      cod(4)=temp(1)
      goto 2000
c
c--'resolution ' directive (value of resol interval)
c   sin(theta)/lambda**3 interval
2500  continue
      if(jredf(temp,1)) 2060,2052,2052
2052  continue
      if(temp(1).eq.0.0) temp(1)=-1.0
      cod(7)=temp(1)
      goto 2000
c
c--'print' directive print refl. with /fo-fc/ greater than cod(6)*fo
2600  continue
      if(jredf(temp,1)) 2060,2092,2092
2092  continue
      if(temp(1).eq.0.0)cod(6)=0.5
      cod(6)=temp(1)
      goto 2000
c
c--'verbose' directive  
2700  continue
      icod(5)=1
      go to 2000
c
c--'dump ' directive (fo/fc in funzione di sin(theta)/lambda'(if icod(20)=1)
2800  continue
	itype=0
	ext=' '
	call rdfile(itst1,ext,itemp1,carctr,itype,ier)
	if(ier.eq.-1) goto 9100
	if(ier.eq.1) goto 2060
      if(iopen(ncpu,carctr,ier)) 2060,2516,2516
2516  continue
      write(ncwu,2515) carctr
2515  format(/,' output file = ',a,/)
      icod(20)=1
      go to 2000
c
c--'apply' directive
2900  continue
      icod(8)=1
      if(jredf(temp,1)) 2060,2942,2942
2942  continue
      if(temp(1).eq.0.0) temp(1)=-1.0
      cod(9)=temp(1)
      go to 2000
c
c--'select' directive (ifore(2),iclass(8),lkh(7))
c		    icod(10)=1	   =3	   =4
3000  continue
      if(jrca(itemp,n)) 2060,3010,2060
3010  continue
      n=kcomp(1,itemp,ifore,2,1)
      if(n) 3020,3020,3015
3015  continue
      icod(10)=n
      cod(11)=0.0
      cod(12)=0.0
      nc=keq(nc,ib,2)
      nc=kne(nc,ib,2)
      if(nc) 3017,3017,3016
3016  continue
      if(jredf(temp,2)) 2060,3018,3018
3018  continue
      cod(11)=temp(1)
      cod(12)=temp(2)
3017  continue
      go to 2000
3020  continue
      n=kcomp(1,itemp,iclass,8,1)
      if(n) 3050,3050,3025
3025  continue
      icod(10)=3
      icod(11)=n
      go to 2000
3050  continue
      n=kcomp(1,itemp,lkh,7,1)
      if(n) 2060,2060,3055
3055  continue
      icod(10)=4
      icod(11)=n
      goto 2000
c
c--'end' directive
9000  continue
      if(iabort)9010,9010,9100
9010  continue
      call newagr(iclass,lkh,lkhgu)
      return
9100  continue
      iabort=0
      return
      end
c
code for newagr
      subroutine newagr(iclass,lkh,lkhgu)
c
      dimension iclass(8),lkh(7),lkhgu(18)
c--
      include 'li6com.inc'
c
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i               
     3 ,l2a,l2b,l2c,l2d,l2j,noric
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst04/iw4,l4,m4,n4
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      dimension cod(30)
      equivalence(icod,cod)
      common/xtemp/itemp(80)
      dimension     temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      dimension norrif(1001),fo(2,1001)
      dimension der(120,3),contris(120)
c--	dimension norrif(121),fo(121),der(120,3),contris(120),sntl(120)
      dimension fo1f(120),fo2f(120),dif1f(120),dif2f(120),sd2wf(120)
      dimension fc1f(120),npiu(120),nmeno(120),fscal(120)
      dimension	dif1fx(120),fo1fx(120),rfx(120)
      dimension fo1s(120),fo2s(120),dif1s(120),dif2s(120),sd2ws(120)
      dimension rf(120),rwf(120),rs(120),rws(120),sd2wfn(120)
      dimension aap(3),dep(3),det(3,3),aa(3),vvet(3)
      dimension indr(5),jhkl(7),nhkl(7),sd2wsn(120)
      dimension hl(12)
      data nhkl/3,3,5,3,5,5,1/
c--
      icodd=icod(5)
      icod3=icod(3)
c
c--ninter: n.di rifl. per intervallo
c--interv: n. di intervalli
c--read down the lists
      call xcsae
      call xrsl
c--
      call xfl01
      call xfl02
      l2p=nfl
      call xlat(hl)
      nfl=nfl+n2p*md2p
      l=n2p*3
      m2p=l2p
      do i=1,l
      store(m2p)=hl(i)
      m2p=m2p+1
      enddo
      call xfl03
      wave=store(l3g+10)
      call xfl04
      nfltemp=nfl
      call xfl05           
c--scale of /fo/
c      scalo=1.0/abs(store(l5o))
c      scalc=1.0
      scalc=abs(store(l5o))
      scalo=1.0
c--
      jq=1
      call sfl12
      if(jfr22(ix)) 35,36,36
35    continue
      call xerr
      write(ncwu,*)' errore in lista 12'
c--   ier=-1
      return
36    continue
      nfl=nfltemp
      call xfl06
      call sfl22
      if(jab22(ix)) 35,37,37
37    continue
      write(ncwu,50)
50    format(' Agreement analysis ',/,
     2	     ' d2  =   (Fo-Fc)^2 ',/,
     3	     ' wd2 = w*(Fo-Fc)^2 ')
c-- store list 6 in memoria
      il6=6
      j=0
      icode=0
      call xsto6(il6,j,icode,in)
      sntlmn=1000.
      sntlmx=0.
      m6=lxxe
      do i=1,nxxe
      ss=store(m6+7)
      s=sqrt(ss)
      sss=ss
c      sss=s*ss
c$$--
c      if(icod(20).eq.1) then sss=s
c----
      if(sss.gt.sntlmx)sntlmx=sss
      if(sss.lt.sntlmn)sntlmn=sss
      store(m6+6)=sss
      m6=m6+mdxxe
      enddo
c--
c      if(icod(20).eq.1) goto 1100
c
c--sort on Fo to calculate the intervals
      njump=3
      call sortz(lxxe,nxxe,mdxxe,njump)
      intervx=120
      ninterx=120
      interv=0
      if(icod3.ne.8) interv=icod3
      kk=1
      jfirst=0
      call folimi(jfirst,interv,intervx,ninterx,norrif,fo,kk)
      jfirst=1
c
c--sort on (sin(theta)/lambda)3 to calculate the intervals
      njump=6
      call sortz(lxxe,nxxe,mdxxe,njump)
      kk=2
      call folimi(jfirst,interv,intervx,ninterx,norrif,fo,kk)
c--
c--sort on Fo and calculate the R(F) and wR%
      njump=3
      call sortz(lxxe,nxxe,mdxxe,njump)
c
c--calculate for each interval
      d2wmin=1000
      d2wmax=0.
      d2wt1=0.
      do i=1,interv
       sd2wf(i)=0.
       fo1f(i)=0.
       fo1fx(i)=0.
       fc1f(i)=0.
       fo2f(i)=0.
       dif1f(i)=0.
       dif1fx(i)=0.
       dif2f(i)=0.
       npiu(i)=0
       nmeno(i)=0
       fscal(i)=0.0
      enddo
      rwt=0.
      rt=0.
      dif2ft=0.
      fo2ft=0.
      fo1ft=0.
      fo1ftx=0.0
      rtx=0.0
      nchg=0
      n4z=0
      m6=lxxe
      do i=1,interv
       iniz=norrif(i)
       ifin=norrif(i+1)-1
       m6temp=m6
       do k=iniz,ifin
	fobs=store(m6+3)*scalo
	fcal=store(m6+5)*scalc
	dif=fobs-fcal
	diff=abs(dif)
	if(dif.lt.0.0) then
	  nmeno(i)=nmeno(i)+1
	else
	  npiu(i)=npiu(i)+1
	endif
	diff2=diff*diff
	fobs2=fobs*fobs
c	 fodif2=diff2*fobs2
	st=sqrt(store(m6+7))
	sigmaf=store(m6+4)*scalo
	call sweig(fobs,fcal,sigmaf,st,diff,w1,n4z)
	d2w=diff2*w1*w1
	dif1f(i)=dif1f(i)+abs(diff)
	dif2f(i)=dif2f(i)+diff2
	fo1f(i)=fo1f(i)+abs(fobs)
	fc1f(i)=fc1f(i)+fcal
	fo2f(i)=fo2f(i)+fobs2*w1*w1
	sd2wf(i)=sd2wf(i)+d2w
c	write(ncwu,*)'k,dif1f(i),dif2f(i),fo1f(i),fo2f(i)',
c     1	 k,dif1f(i),dif2f(i),fo1f(i),fo2f(i)
	m6=m6+mdxxe
       enddo
       contrib=float(ifin-iniz+1)
c	write(ncwu,*)'i,dif1f(i),dif2f(i),fo1f(i),fo2f(i),contrib',
c     1 i,dif1f(i),dif2f(i),fo1f(i),fo2f(i),contrib
       rwf(i)=100.*sqrt(sd2wf(i)/fo2f(i))
       rf(i)=100.*dif1f(i)/fo1f(i)
       fo1ft=fo1f(i)+fo1ft
       rwt=rwt+sd2wf(i)
       rt=rt+dif1f(i)
       fo2ft=fo2ft+fo2f(i)
       dif2ft=dif2ft+dif2f(i)
       sd2wf(i)=sd2wf(i)/contrib
       dif2f(i)=dif2f(i)/contrib
       d2wt1=d2wt1+sd2wf(i)
       icont=int(contrib)
c	write(ncwu,*) 'fo1f(i),fc1f(i)',fo1f(i),fc1f(i)
       fscal(i)=fo1f(i)/fc1f(i)
c--modifica fo con la nuova scala e ricalcola r
       m6=m6temp
       do k=iniz,ifin
	fobs=store(m6+3)*scalo/fscal(i)
	if(icod(8).eq.1) then
	  if(cod(9).lt.0.0) then
	    store(m6+3)=fobs
	    store(m6+4)=store(m6+4)*scalo/fscal(i)
	  else
	    if(store(m6+3).le.cod(9)) then
	     store(m6+3)=fobs
	     store(m6+4)=store(m6+4)*scalo/fscal(i)
	    endif
	  endif
	endif
	fcal=store(m6+5)*scalc
	diff=fobs-fcal
	dif1fx(i)=dif1fx(i)+abs(diff)
	fo1fx(i)=fo1fx(i)+abs(fobs)
	m6=m6+mdxxe
       enddo
       rfx(i)=100.0*dif1fx(i)/fo1fx(i)
       fo1ftx=fo1fx(i)+fo1ftx
       rtx=rtx+dif1fx(i)
      enddo
c--end of calculation
      rtt=rt
      rwtt=rwt
      rt=100.*rt/fo1ft
      rtx=100.*rtx/fo1ftx
      rwt=100.*sqrt(rwt/fo2ft)
      d2wt1=d2wt1/float(interv)
      write(ncwu,9050)rt,rwt 
9050  format(/,'  R(F)%.....',f7.2,
     1	     /,' wR(F^2)%...',f7.2)
      write(ncwu,4003)
c      if(icod(20).eq.1) goto 1100
c      if(icodd.eq.0.and.cod(4).le.0.0.and.cod(7).le.0.0)go to 9999
c      if(cod(7).gt.0.0)go to 1100
c
c--check if directive 'select' was given
      if(icod(10).eq.0) goto 1000
      goto(1000,1100,1200,1200,1200),icod(10)
c
c--table on Fo
1000  continue
      if(icod(10).eq.1) then
      write(ncwu,4010)
4010  format(' N.refl',2x,'h',3x,'k',3x,'l',5x,'Fo',6x,'Fc',
     2 5x,'<d2>',5x,'w',5x,
     3 '<wd2>',3x,'R(F)%',3x,'Resol',/)
      if(cod(11).le.0.0)  cod(11)=store(lxxe+3)*scalo
      if(icod(12).le.0.0) cod(12)=store(lxxe+(nxxe-1)+3)*scalo
      m6=lxxe
      do i=1,nxxe
	fobs=store(m6+3)*scalo
	if(fobs.ge.cod(11).and.fobs.le.cod(12)) then
	ihh=store(m6)
	ikk=store(m6+1)
	ill=store(m6+2)
	fobs=store(m6+3)*scalo
	fcal=store(m6+5)*scalc
	dif=fobs-fcal
	diff=abs(dif)
	diff2=diff*diff
	fobs2=fobs*fobs
	st=sqrt(store(m6+7))
	store(m6+6)=0.5/st
	sigmaf=store(m6+4)*scalo
	call sweig(fobs,fcal,sigmaf,st,diff,w1,n4z)
	d2w=diff2*w1*w1
	rr= 100.0*diff/fobs
	wrr=100.0*sqrt(d2w/(fobs2*w1*w1))
	w2=w1*w1
	write(ncwu,4011)i,ihh,ikk,ill,fobs,fcal,diff,w2,d2w
     1	,rr,store(m6+6)
4011  format(1x,i5,3i4,2f8.2,5f8.3)
      endif
      m6=m6+mdxxe
      enddo
      write(ncwu,4003)
      else
      write(ncwu,4000)
4000  format(2x,'N.refl',3x,'Total',7x,'Fo range',8x,'<d2>',6x,
     1 '<wd2>',5x,'R(F)%',3x,'wR(F^2)%',/)
c--write file autow.tst
c      write(ncpu,4500)interv,rt,rwt
4500  format(i10,2f10.4)
c--write the results  1a tabella
      nn=0
      do i=1,interv
       iniz=norrif(i)
       ifin=norrif(i+1)-1
       contrib=float(ifin-iniz+1)
       ico=int(contrib)
       nn=nn+ico
       write(ncwu,4100)ico,nn,fo(1,i),fo(1,i+1),dif2f(i),sd2wf(i)
     1	,rf(i),rwf(i)
c--write file autow.tst
c	fom=0.5*(fo(1,i+1)+fo(1,i))
c	write(ncpu,4600)ico,fom,sd2wf(i)
4600   format(1x,i5,2f10.4)
c--end of writing
      enddo
      dif2ft=dif2ft/nxxe
      rwtt=rwtt/nxxe
      write(ncwu,4003)
      write(ncwu,4100)nxxe,nxxe,fo(1,1),fo(1,interv+1),dif2ft,rwtt,
     1	rt,rwt
4003  format(1h )
4004  format(//)
4100  format(1x,i5,i10,2x,f6.1,' - ',f6.1,1x,4f10.3)
4005  format(18x,'Average error = ',f10.3)
      sd2wft=0.
      do i=1,interv
       sd=(sd2wf(i)/rwtt-1)
       sd2wfn(i)=abs(sd)
       sd2wft=sd2wft+sd2wfn(i)
      enddo
      sd2wft=sd2wft/interv
      write(ncwu,4003)
      write(ncwu,4005)sd2wft
c--fine stampa prima tabella
      if(icod(8).eq.1) then
c--write the results  2a tabella
      write(ncwu,4111)
4111  format(/,2x,'N.refl',5x,'Fo range',7x,' fo<fc',6x,
     1 'fo>fc',3x,'new-R%',5x,'Scale',/)
      do i=1,interv
       iniz=norrif(i)
       ifin=norrif(i+1)-1
       contrib=float(ifin-iniz+1)
       ico=int(contrib)
       write(ncwu,4110)ico,fo(1,i),fo(1,i+1),nmeno(i),npiu(i)
     1	,rfx(i),fscal(i)
4110  format(1x,i5,2x,f6.1,' - ',f6.1,1x,2i10,2f10.3)
c--end of writing
      enddo
c--check to save reflections
      write(ncwu,4120)rtx
4120  format(/,' R(%) (new).....',f7.2)
       if(icod(20).eq.1) then
	m6=lxxe
	do i=1,nxxe
	 jhkx=store(m6)
	 jkkx=store(m6+1)
	 jlkx=store(m6+2)
	 write(ncpu,4150)jhkx,jkkx,jlkx,(store(m6+j-1),j=4,6),
     1	  store(m6+7)
4150	 format(3i4,4f10.3)
	 m6=m6+mdxxe
	enddo
       endif
      endif
c--end of table on Fo
      endif
      if(icod(10).eq.1) go to 9999
c      if(cod(4).gt.0.01)go to 9999
c
c--sort on resolution (sin(th)/l)
1100  continue
      njump=7
      call sortz(lxxe,nxxe,mdxxe,njump)
      d2wt1=0.
      do i=1,interv
      sd2ws(i)=0.
      fo1s(i)=0.
      fo2s(i)=0.
      dif1s(i)=0.
      dif2s(i)=0.
      enddo
      rwt=0.
      rt=0.
      dif2st=0.
      fo2st=0.
      fo1st=0.
      m6=lxxe
      nchg=0
      n4z=0
      do i=1,interv
       iniz=norrif(i)
       ifin=norrif(i+1)-1
       do k=iniz,ifin
	fobs=store(m6+3)*scalo
	fcal=store(m6+5)*scalc
	diff=abs(fobs-fcal)
	diff2=diff*diff
c	write(ncwu,*) fobs,fcal
c$$--
c	if(icod(20).eq.1) then
c	 rapp=fobs/fcal
c	 write(ncpu,2002) store(m6+6),rapp, fobs,fcal
c2002	 format(2f10.5)
c	end if
c$$--
	fobs2=fobs*fobs
c	fodif2=diff2*fobs2
	sigmaf=store(m6+4)*scalo
	st=sqrt(store(m6+7))
	store(m6+6)=0.5/st
	call sweig(fobs,fcal,sigmaf,st,diff,w1,n4z)
	d2w=diff2*w1*w1
	dif1s(i)=dif1s(i)+abs(diff)
	dif2s(i)=dif2s(i)+diff2
	fo1s(i)=fo1s(i)+fobs
	fo2s(i)=fo2s(i)+fobs2*w1*w1
	sd2ws(i)=sd2ws(i)+d2w
	m6=m6+mdxxe
       enddo
       contrib=float(ifin-iniz+1)
       rws(i)=100*sqrt(sd2ws(i)/fo2s(i))
       rs(i)=100*dif1s(i)/fo1s(i)
c      d2wt1=d2wt1+sd2ws(i)
       rwt=rwt+sd2ws(i)
       dif2st=dif2st+dif2s(i)
       sd2ws(i)=sd2ws(i)/contrib
       dif2s(i)=dif2s(i)/contrib
       fo1st=fo1s(i)+fo1st
       rt=rt+dif1s(i)
       fo2st=fo2st+fo2s(i)
       icont=int(contrib)
      enddo
c$$--
c      if(icod(20).eq.1) goto 9999
c
c--write the table on resolution
      rtt=rt
      rwtt=rwt
      rt=100.*rt/fo1st
      rwt=100.*sqrt(rwt/fo2st)
      if(icod(10).eq.2) then
      write(ncwu,4015)
4015  format(' N.refl',2x,'h',3x,'k',3x,'l',5x,'Fo',6x,'Fc',
     2 5x,'<d2>',5x,'w',5x,
     3 '<wd2>',3x,'R(F)%',3x,'Resol',/)
      if(cod(11).le.0.0) cod(11)= store(lxxe+6)
      if(cod(12).le.0.0) cod(12)= store(lxxe+(nxxe-1)*mdxxe+6)
      m6=lxxe
      do i=1,nxxe
      if(store(m6+6).le.cod(11).and.store(m6+6).ge.cod(12)) then
	ihh=store(m6)
	ikk=store(m6+1)
	ill=store(m6+2)
	fobs=store(m6+3)*scalo
	fcal=store(m6+5)*scalc
	dif=fobs-fcal
	diff=abs(dif)
	diff2=diff*diff
	fobs2=fobs*fobs
	st=sqrt(store(m6+7))
	sigmaf=store(m6+4)*scalo
	call sweig(fobs,fcal,sigmaf,st,diff,w1,n4z)
	d2w=diff2*w1*w1
	rr= 100.0*diff/fobs
	wrr=100.0*sqrt(d2w/(fobs2*w1*w1))
	w2=w1*w1
	write(ncwu,4016)i,ihh,ikk,ill,fobs,fcal,diff,w2,d2w
     1	,rr,store(m6+6)
4016  format(1x,i5,3i4,2f8.2,5f8.3)
      endif
      m6=m6+mdxxe
      enddo
      write(ncwu,4003)
      else
      write(ncwu,4001)
4001  format(/,2x,'N.refl',3x,'Total',6x,'Resol range',6x,'<d2>',6x,
     1 '<wd2>',5x,'R(F)%',3x,'wR(F^2)%',/)
c--write file autow.tst
c      write(ncpu,4500)interv,rt,rwt
c--
      nn=0
      do i=1,interv
      iniz=norrif(i)
      ifin=norrif(i+1)-1
      contrib=float(ifin-iniz+1)
      ico=int(contrib)
      nn=nn+ico
      sntla=0.5/sqrt(fo(2,i))
      sntlb=0.5/sqrt(fo(2,i+1))
      write(ncwu,4101)ico,nn,sntla,sntlb,dif2s(i),sd2ws(i)
     1 ,rs(i),rws(i)
c--write file autow.tst
c      fom=0.5*(fo(2,i+1)+fo(2,i))
c      write(ncpu,4600)ico,fom,sd2ws(i)
      enddo
      rwtt=rwtt/nxxe
      dif2st=dif2st/nxxe
      sntla=0.5/sqrt(fo(2,1))
      sntlb=0.5/sqrt(fo(2,interv+1))
      write(ncwu,4003)
      write(ncwu,4101)nxxe,nxxe,sntla,sntlb,dif2st,rwtt,rt,rwt
4101  format(1x,i5,i10,3x,f6.3,' - ',f6.3,4f10.3)
      write(ncwu,4003)
      sd2wst=0
      do 3501 i=1,interv
c      sd2wsn(i)=(sd2ws(i)/rwtt-1)
      sd=(sd2ws(i)/rwtt-1)
c      sd2wsn(i)=(sd)**2
      sd2wsn(i)=abs(sd)
      sd2wst=sd2wst+sd2wsn(i)
3501  continue
      sd2wst=sd2wst/interv
      write(ncwu,4005)sd2wst
      write(ncwu,4003)
      endif
      if(icod(10).eq.2) goto 9999
      if(icod(5).eq.0)go to 9999
c
c--agreement of  parity groups and hkl classes
1200  continue
c
c-- md=8    1=no. of contributors
c--         2= fo-fc
c--	    3=(fo-fc)^2
c--         4= fo
c--	    5= fo^2
c--	    6= d2w=w*(fo-fc)^2
c--         7= r
c--         8= rw
c--ladgu first address for parity groups
c--ladgu        ggg      
c--ladgu+1*md   ggu      
c--ladgu+2*md   gug      
c--ladgu+3*md   guu      
c--ladgu+4*md   ugg      
c--ladgu+5*md   ugu      
c--ladgu+6*md   uug      
c--ladgu+7*md   uuu      
c--ladhkl=ladgu+8*md               jhkl(7)=ladhkl
c--lad0kl=ladhkl+(dh+dk+dl)*md     jhkl(6)=lad0kl
c--ladh0l=lad0kl+(dk+dl)*md        jhkl(5)=ladh0l
c--lad00l=ladh0l+(dh+dl)*md        jhkl(4)=lad00l
c--ladhk0=lad00l+(dl)*md           jhkl(3)=ladhk0
c--lad0k0=ladhk0+(dh+dk)*md        jhkl(2)=lad0k0
c--ladh00=lad0k0+(dk)*md           jhkl(1)=ladh00
c--nfl   =ladh00+(dh)*md
      ladgu=nfl
      md=8
      ladhkl=ladgu+8*md
      jhkl(7)=ladhkl
      lad0kl=ladhkl+nhkl(7)*md
      jhkl(6)=lad0kl
      ladh0l=lad0kl+nhkl(6)*md
      jhkl(5)=ladh0l
      lad00l=ladh0l+nhkl(5)*md
      jhkl(4)=lad00l
      ladhk0=lad00l+nhkl(4)*md 
      jhkl(3)=ladhk0
      lad0k0=ladhk0+nhkl(3)*md
      jhkl(2)=lad0k0
      ladh00=lad0k0+nhkl(2)*md 
      jhkl(1)=ladh00
      nfl   =ladh00+nhkl(1)*md
      do i=ladgu,nfl
      store(i)=0.
      enddo
c      write(ncwu,*)'lxxe,nxxe',lxxe,nxxe
c      write(ncwu,*)'ladgu,nfl',ladgu,nfl
c      write(ncwu,*)'jhkl',jhkl
c
      if(icod(10).gt.2) then
      write(ncwu,4015)
      endif
      k1=0
      nchg=0
      n4z=0
      m6=lxxe
      do 6000 k=1,nxxe
      ihh=store(m6)
      ik=store(m6+1)
      il=store(m6+2)
c--set code for stampa parziale
      jstam=0
c      if(ihh.eq.0.and.il.eq.0) jstam=1
c--fine
      ipar=iabs(mod(ihh,2)*4)+iabs(mod(ik,2)*2)+iabs(mod(il,2))
      indr(1)=ladgu+ipar*md
      ihkl=7
      if(ihh.eq.0)ihkl=ihkl-1
      if(ik.eq.0)ihkl=ihkl-2
      if(il.eq.0)ihkl=ihkl-4
      laddr=jhkl(ihkl)
      indr(2)=laddr
      ich=0
      indr(3)=-1
      if(ihh.ne.0.and.ihkl.ne.7)then
	indr(3)=laddr+(1+iabs(mod(ihh,2)))*md
	ich=1
      endif
      ick=0
      indr(4)=-1
      if(ik.ne.0.and.ihkl.ne.7)then
	indr(4)=laddr+(1+2*ich+iabs(mod(ik,2)))*md
	ick=1
      endif
      indr(5)=-1
      if(il.ne.0.and.ihkl.ne.7)then
	indr(5)=laddr+(1+2*ich+2*ick+iabs(mod(il,2)))*md
      endif
c      write(ncwu,1) ihh,ik,il,ipar,ihkl,(indr(iii),iii=1,5)
c   1  format(5i4,5i10)
c--stampa parziale
      if(jstam.eq.1) then
       write(ncwu,*)' 0k0=',ihh,ik,il,indr,ihkl
      endif
c--fine stampa
      fobs=store(m6+3)*scalo
      fcal=store(m6+5)*scalc
      diff=abs(fobs-fcal)
      diff2=diff*diff
      fobs2=fobs*fobs
      sigmaf=store(m6+4)*scalo
      st=sqrt(store(m6+7))
      store(m6+6)=0.5/st
      call sweig(fobs,fcal,sigmaf,st,diff,w1,n4z)
      d2w=diff2*w1*w1
      if(icod(10).gt.2) then
	rr= 100.0*diff/fobs
	wrr=100.0*sqrt(d2w/(fobs2*w1*w1))
	w2=w1*w1
	if(icod(10).eq.3.and.(ipar+1).eq.icod(11)) then
	k1=k1+1
	write(ncwu,4011)k1,ihh,ik,il,fobs,fcal,diff,w2,d2w
     1	,rr,store(m6+6)
	else if(icod(10).eq.4.and.ihkl.eq.icod(11)) then
	k1=k1+1
	write(ncwu,4011)k1,ihh,ik,il,fobs,fcal,diff,w2,d2w
     1	,rr,store(m6+6)
      endif
      endif
      do 6100 kk=1,5
      mm=indr(kk)
      if(mm.eq.-1)go to 6100
      store(mm)=store(mm)+1
      store(mm+1)=store(mm+1)+fobs
      store(mm+2)=store(mm+2)+fobs2*w1*w1
      store(mm+3)=store(mm+3)+abs(diff)
      store(mm+4)=store(mm+4)+diff2
      store(mm+5)=store(mm+5)+d2w
c--stampa parziale
      if(jstam.eq.1) then
       write(ncwu,*)' 0k0=',(store(mmm),mmm=mm,mm+5)
      endif
c--fine stampa
6100  continue
6000  m6=m6+mdxxe
      if(icod(10).gt.2) goto 9999
c
c--print gu statistic
      iloop=1
      write(ncwu,6102)
      mm=ladgu
      do 6500 k=1,8
      contrib=store(mm)
      if(contrib.eq.0)go to 6500
      store(mm+7)=100*sqrt(store(mm+5)/store(mm+2))
      store(mm+6)=100*store(mm+3)/store(mm+1)
      store(mm+5)=store(mm+5)/contrib
      store(mm+4)=store(mm+4)/contrib
      d2wt1=d2wt1+store(mm+5)
      ico=int(contrib)
      write(ncwu,6101)iclass(k),ico,store(mm+4),store(mm+5),
     1 store(mm+6),store(mm+7)
6500  mm=mm+md
6102  format(3x,'Class',2x,'N.refl.',6x,'<d2>',10x,
     1 '<wd2>',9x,'R(F)%',7x,'wR(F^2)%',/)
6101  format(3x,a4,i8,2x,f10.3,5x,f10.3,2(5x,f9.3))
      write(ncwu,4003)
c--print the hkl statistic
      write(ncwu,6102)
      do 6600 k=1,7
      mm=jhkl(k)
      contrib=store(mm)
      if(contrib.eq.0)go to 6600
      store(mm+7)=100*sqrt(store(mm+5)/store(mm+2))
      store(mm+6)=100*store(mm+3)/store(mm+1)
      store(mm+5)=store(mm+5)/contrib
      store(mm+4)=store(mm+4)/contrib
      d2wt1=d2wt1+store(mm+5)
      ico=int(contrib)
      write(ncwu,6101)lkh(k),ico,store(mm+4),store(mm+5),
     1 store(mm+6),store(mm+7)
6600  mm=mm+md
      write(ncwu,4003)
c--print partial hkl  statistic
      write(ncwu,6102)
      kkk=0
      do 6700 k=1,6
      mm=jhkl(k)+md
      do 6751 kk=1,nhkl(k)-1
      contrib=store(mm)
      ico=int(contrib)
      kkk=kkk+1
c      write(ncwu,2) kkk,k,kk,jhkl(k),mm,ico,nhkl(k)
c   2  format(3i4,4i10)
      if(ico.eq.0)go to 6750
      store(mm+7)=100*sqrt(store(mm+5)/store(mm+2))
      store(mm+6)=100*store(mm+3)/store(mm+1)
      store(mm+5)=store(mm+5)/contrib
      store(mm+4)=store(mm+4)/contrib
      d2wt1=d2wt1+store(mm+5)
      write(ncwu,6101)lkhgu(kkk),ico,store(mm+4),store(mm+5),
     1 store(mm+6),store(mm+7)
6750  mm=mm+md
6751  continue
6700  continue
9999  continue
      write(ncwu,4003)
c-- print  reflections with /fo - fc/.gt.z (default z=0.5)
c      write(ncwu,*)'cod(6)',cod(6)
      if(cod(6).gt.0.0)  then
      njump=3
      call sortz(lxxe,nxxe,mdxxe,njump)
      z=cod(6)
      write(ncwu,1)z
1     format(3x,'List reflections with (Fo - Fc)/Fo > ',
     1f3.1//,6x,'Reflection',8x,'Fo',8x,'Fc',
     2 7x,'Fo-Fc',3x,'Sig(Fo)',5x,'Resol',/)
      n=0
      m6=lxxe
      do i=1,nxxe
	fobs=store(m6+3)*scalo
	fcal=store(m6+5)*scalc
	diff=fobs-fcal
	diff2=abs(diff)
c	write(ncwu,*) fobs,fcal,diff
	sigmaf=store(m6+4)*scalo
	st=sqrt(store(m6+7))
	resol= 0.5/st
	e=  z*fobs
	if(diff2.gt.e) then
	  n=n+1
	  write(ncwu,2)(store(m),m=m6,m6+2),fobs,fcal,diff,
     1	   sigmaf,resol
2	  format(3x,3f5.0,4f10.3,f10.4)
	endif
      m6=m6+mdxxe
      enddo
      write(ncwu,3)n
3     format(/,3x,i6,' reflections found',/)
      endif
c      write(ncwu,*)'prima del return'
      return
      end
